<?php
// File: $Id: fix.php,v 1.7 2002/09/24 00:29:49 madhatter7 Exp $ $Name:  $
// ----------------------------------------------------------------------------
// Envolution Content Management System
// Copyright (C) 2002 by the Envolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// ----------------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------------
// Original Author of file: Marino
// Purpose of file:
// ----------------------------------------------------------------------------


// functions for the db abstraction layer
define('ADODB_DIR',	'pnadodb');
require_once ("pnadodb/adodb.inc.php");
require_once ("includes/pnAPI.php");


////
// Save configuration value
// @access      private
// @author      marino
// @param       string  $module     the module name
// @param       string  $name       name of the module variable
// @param       string  $value      the value of the module variable
// @param       bool    $overwrite  flag to overwrite existing data
// @return      none
function SaveConfigValue($module, $name, $value, $overwrite)
{
	$dbconn = $GLOBALS[dbconn];
	$prefix = $GLOBALS[prefix];

	$result = $dbconn->Execute("SELECT pn_value from ".$prefix."_module_vars 
								WHERE pn_name='".$name."' 
								AND pn_modname='".$module."'");

	if ($result->EOF)
	{
		$dbconn->Execute("INSERT INTO ".$prefix."_module_vars (pn_modname,
																pn_name,
																pn_value) 
										VALUES ('".$module."',
												'".$name."',
												'".serialize($value)."')");
	} else {
		if ($overwrite)
		{
			$dbconn->Execute("UPDATE ".$prefix."_module_vars 
							  SET pn_value='".serialize($value)."' 
							  WHERE pn_modname='".$module."' 
							  AND pn_name='".$name."'" );
		}
	}
}


////
// Save Addon configuration
// @access      private
// @author      marino
// @param       string  $module     the name of the module
// @param       string  $name       the name of the variable to set
// @param       string  $value      the value of the module varaible
function SaveConfigValueAddOn($module, $name, $value)
{
	$dbconn = $GLOBALS[dbconn];
	$prefix = $GLOBALS[prefix];

	$dbconn->Execute("INSERT INTO ".$prefix."_module_vars (pn_modname,
														   pn_name,
														   pn_value) 
										VALUES ('".$module."',
												'".$name."',
												'".$value."')");
}


////
// Check to see if a table exists
// @access      private
// @author      marino
// @param       string  $table_name the name of the table
// @return      bool                true if table is found
function CheckTableExists($table_name)
{
	$result = mysql_list_tables($GLOBALS[dbname]);
	while ($row = mysql_fetch_row($result))
	{
		if ($row[0] == "$GLOBALS[prefix]_$table_name")
		{
			return true;
		}
	}

	return false;
}


////
// Check for table field
// @access      private
// @author      marino
// @param       string  $field_name the name of the field
// @param       string  $table_name the name of the table
// @return      bool                true if field is found in table
function CheckForField($field_name, $table_name)
{
	$result = mysql_query("desc $GLOBALS[prefix]_$table_name");
	while ($row = mysql_fetch_array($result))
	{
		if ($row[Field] == $field_name)
		{
			return (true);
		}
	}

	return(false);
}


////
// Connect to the database
// @access      private
// @author      marino
// @param       string  $dbhost     database hostname
// @param       string  $dbuname    database user name
// @param       string  $dbpass     database user password
// @param       string  $dbtype     database type (mysql, mssql, etc)
// @return      object  $dbconn     the database connection
function dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype='mysql')
{
	$connectString = "$dbtype://$dbuname:$dbpass@$dbhost/$dbname";

	GLOBAL $ADODB_FETCH_MODE;

	$dbconn = &ADONewConnection($dbtype);
	$dbh = $dbconn->Connect($dbhost, $dbuname, $dbpass, $dbname);
	$ADODB_FETCH_MODE = ADODB_FETCH_NUM;

	// if we get an error, log it and die
	if ($dbh === false)
	{
		error_log ("connect string: $connectString");
		error_log ("error: " . $dbconn->ErrorMsg());

		// show error and die
		PN_DBMsgError($dbconn, __FILE__ , __LINE__, "Error connecting to db");
	} else {
		return $dbconn;
	}
}


////
// Database error messages
// @access      public
// @author      marino
// @param       object  $db         the database object
// @param       string  $prg        the program name
// @param       int     $line       the line number where the error occured
// @param       string  $message    the supplied error message from the program
// @return      none                display message and die
// @note        copied from mainfile.php because it is not incldued
function PN_DBMsgError($db='',$prg='',$line=0,$message='Error accessing the database')
{
	$lcmessage = $message . '<br />'.
	'Program: '.$prg.' - '.'Line No.: '.$line.'<br />'.
	'Database: '.$db->database.'<br /> ';

	if($db->ErrorNo() <> 0)
	{
		$lcmessage .= 'Error ('.$db->ErrorNo().') : '.$db->ErrorMsg().'<br />';
	}

	die($lcmessage);
}


if(!isset($prefix))
{
	include_once 'config.php';

	$prefix		= $pnconfig['prefix'];
	$dbtype		= $pnconfig['dbtype'];
	$dbhost		= $pnconfig['dbhost'];
	$dbuname	= $pnconfig['dbuname'];
	$dbpass		= $pnconfig['dbpass'];
	$dbname		= $pnconfig['dbname'];
	$system		= $pnconfig['system'];
	$encoded	= $pnconfig['encoded'];
}

if (!empty($encoded))
{
	// Decode username and password
	$dbuname = base64_decode($dbuname);
	$dbpass = base64_decode($dbpass);
}

$pnconfig['prefix']	= $prefix;


echo "
		<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">
		<html><head><title>Envolution 1.0.0 Upgrade Fix</title>
		<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset='ISO-8859-1'\">
		<META NAME=\"AUTHOR\" CONTENT=\"Envolution Staff\">
		<META NAME=\"GENERATOR\" CONTENT=\"Envolution -- http://www.envolution.com\">
				<style>
/*TD, P, DIV, INPUT, TEXTAREA, FORM {
  font-family: Arial, Helvetica;
  font: x-small;
  COLOR: #ffffff;
  LINE-HEIGHT: 15px
}*/

INPUT, TEXTAREA, FORM, SELECT {
  font-family: Arial, Helvetica;
  font: x-small;
  COLOR: #ffffff;
  background-color: #415E74;
  LINE-HEIGHT: 15px
}

body {
  margin: 0px;
  padding: 0px;
  background-color: #000000;
  font-family: Arial, Helvetica;
  font-size: x-small;
  font-weight: medium;
  color: #ffffff;
  scrollbar-face-color: #000000;
  scrollbar-shadow-color: #ffffff;
  scrollbar-highlight-color: #ffffff;
  scrollbar-3dlight-color: #99B7CC;
  scrollbar-darkshadow-color: #99B7CC;
  scrollbar-track-color: #ffffff;
  scrollbar-arrow-color: #ffffff;
}

A:link {
COLOR: #99B7CC;
FONT-SIZE: x-small;
FONT-FAMILY: Arial, Helvetica;
TEXT-DECORATION: none;
}
A:visited {
COLOR: #ffffff;
FONT-SIZE: x-small;
FONT-FAMILY:  Arial, Helvetica;
TEXT-DECORATION: none;
}
A:hover	{
COLOR: #ffffff;
FONT-SIZE: x-small;
FONT-FAMILY: Arial, Helvetica;;
TEXT-DECORATION: none;
}
A:active {
COLOR: #ffffff;
FONT-SIZE: x-small;
FONT-FAMILY: Arial, Helvetica;
TEXT-DECORATION: none;
}
.pn-pagetitle {
  font-family: Arial, Helvetica;
  font-size: medium;
  font-weight: bold;
  color: #ffffff;
}
.pn-sub	{
  font-family: Arial, Helvetica;
  font-size: xx-small;
  font-weight: small;
  color: #ffffff;
</style>
		</head>
		<!--  Page Header  -->
		<body bgcolor=\"#000000\">
		<br /><br />
		<!--  Main Content  -->
		<table width=\"760\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" align=\"center\" bgcolor=\"#000000\">
	<tr>
	<td bgcolor=\"#415E74\"><img src=\"install/images/spacer.gif\" width=\"15\" /></td>
	<td width=\"730\" bgcolor=\"#415E74\" align=\"center\" valign=\"top\">
		<font class=\"pn-pagetitle\"><center>Envolution 1.0.0 Upgrade Fix</center></font>
		<br /><br />";

if ($accept != 'on') {
	echo "<h2>--- WARNING --- WARNING ---</h2> <br>
		This fix will <b>DELETE</b> your current settings for Encompass themes already installed.
		After running this script, your Encompass themes available will be <b>only</b> the ones packaged with Envolution 1.0.0
		Also, your default theme will be set to Envolved, so please be sure to have needed themes files installed.
		Available Encompass themes after fix will be:<br><br>
		 DuskyBlue<br>
		 Envolved (default theme after fix)<br>
		 LiquidLogic<br>
		 LogicII<br>
		 PiterpanV2<br>
		 X-Indus<br><br><br>

	 After running this script, you can install back any theme you had previously.<br><br>

		 If you agree with those terms, please check your database connection info and press the button below.<br><br>

		<h2>--- AVISO --- AVISO ---</h2>
		Este parche <b>BORRAR</b> tus preferencias, zonas y disposiciones actuales para themes que ya tengas instalados. Tras
		la ejecucin de este script, Los themes disponibles sern <b>solo</b> los distribuidos con Envolution 1.0.0
		El theme por defecto ser puesto como Envolved, as que asegrate de que tienes instalados los ficheros necesarios del theme
		Los themes de Encompass disponibles tras la actualizacin sern:<br><br>
		 DuskyBlue<br>
		 Envolved (theme por defecto tras el parche)<br>
		 LiquidLogic<br>
		 LogicII<br>
		 PiterpanV2<br>
		 X-Indus<br><br><br>

		 Puedes volver a instalar los themes que tenas una vez hayas ejecutado este script.<br><br>

		 Si aceptas estos trminos, por favor comprueba la informacin de conexin a tu base de datos y pulsa el botn.<br><br>";

   echo    "
<font class=\"pn-title\">Change Info</font><font class=\"pn-normal\">"._CHANGE_INFO_1."<br /><br />
<form action=\"fix.php\" method=\"post\"><center>
<input type='hidden' name='accept' value='on'>


		<table cellspacing=\"0\" cellpadding=\"1\" border=\"0\">
		<tr><td align=\"left\"><font class=\"pn-normal\">Database hostname</font></td>
		<td><input type=\"text\" NAME=\"dbhost\" SIZE=20 maxlength=80 value=\"$dbhost\"></td></tr>
		<tr><td align=\"left\"><font class=\"pn-normal\">Database user</font></td>
		<td><input type=\"text\" NAME=\"dbuname\" SIZE=20 maxlength=80 value=\"$dbuname\"></td></tr>
		<tr><td align=\"left\"><font class=\"pn-normal\">Database user password</font></td>
		<td><input type=\"text\" NAME=\"dbpass\" SIZE=20 maxlength=80 value=\"$dbpass\"></td></tr>
		<tr><td align=\"left\"><font class=\"pn-normal\">Database name</font></td>
		<td><input type=\"text\" NAME=\"dbname\" SIZE=20 maxlength=80 value=\"$dbname\"></td></tr>
		<tr><td align=\"left\"><font class=\"pn-normal\">Prefix</font></td>
		<td><input type=\"text\" NAME=\"prefix\" SIZE=20 maxlength=80 value=\"$prefix\"></td></tr>
		<tr><td align=\"left\"><font class=\"pn-normal\">Database type</font></td>
		<td><select name=\"dbtype\"><option value=\"mysql\" selected>&nbsp;MySQL&nbsp;</option>
		</select></td></tr>
		</table>

<input type=\"hidden\" name=\"op\" value=\"Submit\">
<input type=\"submit\" value=\"Go\"></center></form></font>";
}

switch(@$op)
{
	case 'Submit':
		echo 'Connecting to database ... ';
		$dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
		echo "OK<br />";
		echo "Creating autolinks table ... ";
		$dbconn->Execute("CREATE TABLE ".$prefix."_autolinks (
										pn_lid int(11) NOT NULL auto_increment,
										pn_keyword varchar(100) NOT NULL default '',
										pn_title varchar(100) NOT NULL default '',
										pn_url varchar(200) NOT NULL default '',
										pn_comment varchar(200) NOT NULL default '',
							PRIMARY KEY  (pn_lid),
							UNIQUE KEY keyword (pn_keyword))");

		if (CheckTableExists("autolinks"))
		{
			echo "OK<br>";
		} else {
			die("Unable to create table ".$prefix."_autolinks, It seems there is something wrong with your permissions or your database");
		}

	   //NoMoreBlocks
		echo "Creating nomoreblocks table ... ";
	   $dbconn->Execute("CREATE TABLE ".$prefix."_nomoreblocks (
									pn_modulo varchar(32) NOT NULL default '',
									pn_blocco varchar(32) NOT NULL default '',
									pn_identi varchar(32) NOT NULL default '',
									pn_pos varchar(4) NOT NULL default '',
									pn_peso decimal(10,1) NOT NULL default '1.0',
						PRIMARY KEY  (pn_blocco,pn_modulo))");

		if (CheckTableExists("nomoreblocks"))
		{
		   echo "OK<br>";
		}
		else {
		  die("Unable to create table ".$prefix."_nomoreblocks, It seems there is something wrong with your permissions or your database");
		}

	  //***************NEWS**********************
	  echo "Updating Current News Tables ... ";

	  // Update the information in the database for News
	  $result = $dbconn->Execute("DELETE FROM ".$prefix."_modules WHERE pn_name='News'");
	  $result = $dbconn->Execute("INSERT INTO ".$prefix."_modules
														VALUES (23,
																'News',
																2,
																'News',
																'News items',
																7,
																'News',
																'1.5',
																1,
																1,
																3)");
	  if($dbconn->ErrorNo() != 0) {
		 die("Unable to update database");
	  }
	  $result->Close();
	  echo "OK<br>";


		  //*******autolinks**********
		// webmedic: update needed to properly initialze autolinks.

		   echo "Checking existing Autolinks tables ... ";
		$result = $dbconn->Execute("SELECT pn_name FROM ".$prefix."_modules where pn_name='Autolinks'");
		$foundrecords = !$result->EOF;
		   echo "OK<br>";
		   echo "";

		if ($foundrecords) {
			echo "Deleting row for Autolinks ... ";
			$result = $dbconn->Execute("DELETE FROM ".$prefix."_modules WHERE pn_name='Autolinks'");
		}
		   echo "OK<br>";
		   echo "";
		   echo "Inserting corrected rows for Autolinks ... ";
		$result = $dbconn->Execute("INSERT INTO ".$prefix."_modules
														VALUES (9,
																'Autolinks',
																2,
																'Autolinks',
																'Automatically add links to text',
																11,
																'Autolinks',
																'1.0',
																1,
																0,
																3)") or die("<b>"._NOTUPDATED.$prefix."_modules</b>");

		   echo "OK<br>";
		   echo "Checking existing Autolinks hooks ... ";
		$result = $dbconn->Execute("SELECT  pn_tmodule FROM ".$prefix."_hooks where  pn_tmodule='Autolinks'");
		$foundrecords = !$result->EOF;
		   echo "OK<br>";
		   echo "";

		if (!$foundrecords)
		{
			echo "Inserting Autolinks hooks ... ";
			$result = $dbconn->Execute("INSERT INTO ".$prefix."_hooks 
										VALUES (3, 
												'item', 
												'transform', 
												NULL, 
												NULL, 
												'API', 
												'Autolinks', 
												'user', 
												'transform')") || die("<b>"._NOTUPDATED.$prefix."_hooks</b>");
			   echo "OK<br>";
		} else {
		   echo "Autolinks hooks are up to date already";
		}

		list($dbconn) = pnDBGetConn();
		$pntable = pnDBGetTables();

		// Setup the table and column info
		$table = $pntable['module_vars'];
		$column = &$pntable['module_vars_column'];

		// Get the next available skin id
		$id = $dbconn->GenId($table);

		   echo "Checking existing Autolinks variables ... ";
		$result = $dbconn->Execute("Select pn_modname FROM ".$prefix."_module_vars WHERE pnmodname='Autolinks'");
		$foundrecords = !$result->EOF;
		   echo "OK<br>";
		   echo "";

		if($foundrecords) {
		   echo "Inserting Autolinks variables ... ";
		   $result = $dbconn->Execute("INSERT INTO ".$prefix."_module_vars VALUES($id, 'Autolinks', 'itemsperpage', 20)") || die("<b>"._NOTUPDATED.$prefix."_module_vars</b>");
		   $result = $dbconn->Execute("INSERT INTO ".$prefix."_module_vars VALUES($id, 'Autolinks', 'linkfirst', 1)") || die("<b>"._NOTUPDATED.$prefix."_module_vars</b>");
		   $result = $dbconn->Execute("INSERT INTO ".$prefix."_module_vars VALUES($id, 'Autolinks', 'invisilinks', 0)") || die("<b>"._NOTUPDATED.$prefix."_module_vars</b>");
		   echo "OK<br>";
		} else{
		   echo "Autolinks variables are up to date already";
		}
	  //************end autolinks************


	  //*******POLLS**************
	   echo "Checking existing Polls tables ... ";
	  //ak_comment: module is looking for modvar which is not created by this update, adding here
	  SaveConfigValueAddOn('Polls','OPTIONCOLOR','#009900');
	  //ak_comment end
	   if (CheckTableExists("poll_voters")) {
		  $result = $dbconn->Execute("SELECT pn_pollid, pn_voteid, pn_uid, pn_timestamp FROM ".$prefix."_poll_voters");

		  if ($dbconn->ErrorNo() != 0) {
			die("Unknown format for table ".$prefix."_poll_voters...");
		  }
		  $result->Close();
	   }
	   else {
		$dbconn->Execute("CREATE TABLE ".$prefix."_poll_voters (
				  pn_pollid int(11) NOT NULL default '0',
				  pn_voteid int(11) NOT NULL default '0',
				  pn_uid int(11) NOT NULL default '0',
				  pn_timestamp int(11) NOT NULL default '0',
				  KEY pn_pollid (pn_pollid),
				  KEY pn_uid (pn_uid)
		 )");
	   }
	   echo "OK<br>";
	   echo "Upgrading Polls to version 1.6! ... ";

	   if (!CheckForField('pn_votesystem', 'poll_desc')) {
			  $dbconn->Execute("ALTER TABLE ".$prefix."_poll_desc ADD `pn_votesystem` VARCHAR(3) DEFAULT 'D' NOT NULL;");
			  if ($dbconn->ErrorNo() != 0) {
					die("Can not alter table ".$prefix."_poll_desc...ADD pn_votesystem");
			  }
	   }
	   else { // upgrade it
		 $dbconn->Execute("ALTER TABLE ".$prefix."_poll_desc CHANGE `pn_votesystem` `pn_votesystem` VARCHAR(3) DEFAULT 'D' NOT NULL;");
		 if ($dbconn->ErrorNo() != 0) {
			die("Can not alter table ".$prefix."_poll_desc.. CHANGE pn_votesystem");
		 }
	   }


	   //upgrade to 1.6 now
	   if (!CheckForField('pn_postfull', 'poll_desc')) {
		   $dbconn->Execute("ALTER TABLE ".$prefix."_poll_desc ADD `pn_postfull` TINYINT(1) DEFAULT '0' NOT NULL;");
		   if ($dbconn->ErrorNo() != 0) {
			 die("Can not alter table ".$prefix."_poll_desc.. ADD pn_postfull.");
		   }
	   }
	   if (!CheckForField('pn_votetracking', 'poll_desc')) {
			   $dbconn->Execute("ALTER TABLE ".$prefix."_poll_desc ADD `pn_votetracking` INT(1) DEFAULT '0' NOT NULL;");
			   if ($dbconn->ErrorNo() != 0) {
					 die("Can not alter table ".$prefix."_poll_desc... ADD pn_votetracking");
			   }
	   }
	   if (!CheckForField('pn_optioncolor', 'poll_data')) {
			   $dbconn->Execute("ALTER TABLE ".$prefix."_poll_data ADD pn_optioncolor VARCHAR( 7 ) DEFAULT '#009900' NOT NULL ;");
			   if ($dbconn->ErrorNo() != 0) {
					 die("Can not alter table ".$prefix."_poll_data... ADD pn_optioncolor");
			   }
	   }

	   // last check
	   if (CheckTableExists("poll_voters")) {
				  echo "OK<br>";
		}
		   else {
			 die("Unable to create table ".$prefix."_poll_voters, It seems there is something wrong with your permissions or your database");
	   }
	  //*********************



				 echo "Deleting table ".$prefix."_theme_skins ... ";
				 $dbconn->Execute("DROP TABLE ".$prefix."_theme_skins");
				 echo "OK<br>";
				 echo "Deleting table ".$prefix."_theme_zones ... ";
				 $dbconn->Execute("DROP TABLE ".$prefix."_theme_zones");
				 echo "OK<br>";
				 echo "Deleting table ".$prefix."_theme_layout ... ";
				 $dbconn->Execute("DROP TABLE ".$prefix."_theme_layout");
				 echo "OK<br>";
				 echo "Deleting table ".$prefix."_theme_config ... ";
				 $dbconn->Execute("DROP TABLE ".$prefix."_theme_config");
				 echo "OK<br>";
				 echo "<br>Checking that tables are deleted ...<br>";
				 echo $prefix."_theme_skins ... ";
				 $allok = 0;
				 if (CheckTableExists("theme_skins")) {
				   $allok = 1;
				   echo "<b>Error.</b> It still exists. It seems you dont have delete permissions. Don't panic, will try B-Plan<br>";
				 } else echo "OK<br>";
				 echo $prefix."_theme_zones ... ";
				 if (CheckTableExists("theme_zones")) {
				   $allok = $allok + 2;
				   echo "<b>Error.</b> It still exists. It seems you dont have delete permissions. Don't panic, will try B-Plan<br>";
				 } else echo "OK<br>";
				 echo $prefix."_theme_layout ... ";
				 if (CheckTableExists("theme_layout")) {
				   $allok = $allok + 4;
				   echo "<b>Error.</b> It still exists. It seems you dont have delete permissions. Don't panic, will try B-Plan<br>";
				 } else echo "OK<br>";
				 echo $prefix."_theme_config ... ";
				 if (CheckTableExists("theme_config")) {
				   $allok = $allok + 8;
				   echo "<b>Error.</b> It still exists. It seems you dont have delete permissions. Don't panic, will try B-Plan<br>";
				 } else echo "OK<br>";

				 echo "<br>";

				 if ($allok > 0) { // Let's try B-Plan
				   echo "Trying to modify current tables<br>";
				   echo "First, we will empty them, then we will modify the table structure. Let's go.<br>";
				   echo "Deleting data from ".$prefix."_theme_layout ... ";
				   $result = $dbconn->Execute("DELETE FROM ".$prefix."_theme_layout");
				   echo "OK<br>";
				   echo "Deleting data from ".$prefix."_theme_skins ... ";
				   $result = $dbconn->Execute("DELETE FROM ".$prefix."_theme_skins");
				   echo "OK<br>";
				   echo "Deleting data from ".$prefix."_theme_config ... ";
				   $result = $dbconn->Execute("DELETE FROM ".$prefix."_theme_config");
				   echo "OK<br>";
				   echo "Deleting data from ".$prefix."_theme_zones ... ";
				   $result = $dbconn->Execute("DELETE FROM ".$prefix."_theme_zones");
				   echo "OK<br>";
				   // OK, tables are empty. Now will try to create new fields if they doesnt exists
				   if (!CheckForField("skin_id","theme_zones")) {
					 $dbconn->Execute("ALTER TABLE ".$prefix."_theme_zones ADD skin_id int(3) NOT NULL default '0'");
				   }
				   if (!CheckForField("skin_id","theme_config")) {
					 $dbconn->Execute("ALTER TABLE ".$prefix."_theme_config ADD skin_id int(3) NOT NULL default '0'");
				   }
				   $letspray = 0;

				   if (CheckForField("skin_id","theme_zones")) {
					 if (CheckForField("skin_id","theme_config")) {
						   echo "B Plan worked. Proceeding with the rest of the script<br>";
						 } else $letspray = 1;
				   } else $letspray = 1;

				   if ($letspray) {
					 die ("B plan failed and there isnt C Plan. This script hasnt been able to delete required tables neither to add required fields. This can	be a problem with your user permissions on the database. You need to delete by hand the next tables and run this script again:<br>".$prefix."_theme_skins,".$prefix."_theme_layout,".$prefix."_theme_zones and ".$prefix."_theme_config.");
				   }

				 } else { //Everything went ok. Just create new tables
					echo "Making table ".$prefix."_theme_layout ... ";
					$result = $dbconn->Execute("CREATE TABLE ".$prefix."_theme_layout (
								skin_id int(3) NOT NULL default '0',
								zone_label varchar(20) NOT NULL default '',
								tpl_file varchar(20) NOT NULL default '',
								KEY (skin_id))")  ;
					if (CheckTableExists("theme_layout")) {
						  echo "OK<br>";
						} else {
						  die ("Unable to create table ".$prefix."_theme_layout. It seems there is something wrong with your permissions or your database");
						}
					echo "Making table ".$prefix."_theme_config ... ";
						$result = $dbconn->Execute("CREATE TABLE ".$prefix."_theme_config (
								name varchar(20) NOT NULL default '',
								skin_id int(3) NOT NULL NOT NULL default '1',
								description varchar(60) NOT NULL default '',
								setting varchar(10) NOT NULL default '',
								data varchar(150) NOT NULL default '',
								KEY (skin_id))");
					if (CheckTableExists("theme_config")) {
						  echo "OK<br>";
						} else {
						  die ("Unable to create table ".$prefix."_theme_config. It seems there is something wrong with your permissions or your database");
						}
					echo "Making table ".$prefix."_theme_zones ... ";
					$result = $dbconn->Execute("CREATE TABLE ".$prefix."_theme_zones (
								zone_id int(3) NOT NULL auto_increment,
								skin_id int(3) NOT NULL default '1',
								name varchar(40) NOT NULL default 'No Name',
								label varchar(20) NOT NULL default 'addon',
								type int(1) NOT NULL default '1',
								is_active int(1) NOT NULL default '0',
								PRIMARY KEY  (zone_id),
								KEY (skin_id))");
					if (CheckTableExists("theme_zones")) {
						  echo "OK<br>";
						} else {
						  die ("Unable to create table ".$prefix."_theme_zones. It seems there is something wrong with your permissions or your database");
						}
					echo "Making table ".$prefix."_theme_skins ... ";
						   $result = $dbconn->Execute("CREATE TABLE ".$prefix."_theme_skins (
								skin_id int(3) NOT NULL auto_increment,
								name varchar(60) NOT NULL default '',
								is_active int(1) NOT NULL default '0',
								is_multicolor int(1) NOT NULL default '0',
								bgcolor1 varchar(12) NOT NULL default '#FFFFFF',
								bgcolor2 varchar(12) NOT NULL default '#FFFFFF',
								bgcolor3 varchar(12) NOT NULL default '#FFFFFF',
								bgcolor4 varchar(12) NOT NULL default '#FFFFFF',
								bgcolor5 varchar(12) NOT NULL default '#FFFFFF',
								bgcolor6 varchar(12) NOT NULL default '#FFFFFF',
								sepcolor varchar(12) NOT NULL default '#000000',
								textcolor1 varchar(12) NOT NULL default '#000000',
								textcolor2 varchar(12) NOT NULL default '#000000',
								PRIMARY KEY  (skin_id))");
					if (CheckTableExists("theme_skins")) {
						  echo "OK<br>";
						} else {
						  die ("Unable to create table ".$prefix."_theme_skins. It seems there is something wrong with your permissions or your database");
						}
				 }

		 //At this poing all tables should be made and empty. Just insert data.
				 echo "<br>";
				 echo "Inserting data ... <br>";
				 echo "skins ... ";

  // Insert skin Envolved
  $dbconn->Execute("INSERT INTO ".$prefix."_theme_skins
								VALUES (1,
												'Envolved',
												1,
												0,
												'#415E74',
												'#415E74',
												'#415E74',
												'#415E74',
												'#99B7CC',
												'#415E74',
												'#415E74',
												'#FFFFFF',
												'#FFFFFF')");

				echo "OK<br>";
				echo "Inserting layout, zones and config ... ";

		$dbconn->Execute("INSERT INTO ".$prefix."_theme_config
								VALUES ('pagewidth',1,'Overall Page Width','100%','')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_config
								VALUES ('lcolwidth',1,'Left Column Width','140','')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_config
								VALUES ('rcolwidth',1,'Right Column Width','170','')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_config
								VALUES ('indexcol',1,'Number of News Columns','1','')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_config
								VALUES ('righton',1,'Right Blocks Always On','0','')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_config
								VALUES ('iblkwidth',1,'Inner Block Width','145','')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
								VALUES (1,'master1','master1.tpl')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
								VALUES (1,'master2','master2.tpl')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
								VALUES (1,'lsblock','lsblock.tpl')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
								VALUES (1,'rsblock','rsblock.tpl')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
								VALUES (1,'table1','table1.tpl')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
								VALUES (1,'table2','table2.tpl')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
								VALUES (1,'News-index','News-index.tpl')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
								VALUES (1,'News-article','News-article.tpl')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
								VALUES (1,'News-index2','News-index2.tpl')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
								VALUES (1, 'topcenter', 'topcenter2.tpl')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
								VALUES (1, 'tcblock', 'tcblock.tpl')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
								VALUES (1, 'botcenter', 'botcenter.tpl')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
								VALUES (1, 'bcblock', 'bcblock.tpl')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
								VALUES (1, 'inblock', 'inblock.tpl')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
								VALUES (1, 'isblock', 'isblock.tpl')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
								VALUES (1, 'dsblock', 'dsblock.tpl')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
								VALUES (1, 'mainmenu', 'mainmenu.tpl')");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
								VALUES (1, 'Master Zone 1', 'master1', 0, 1)");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
								VALUES (1, 'Master Zone 2', 'master2', 0, 1)");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
								VALUES (1, 'Open Table1', 'table1', 0, 1)");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
								VALUES (1, 'Open Table2', 'table2', 0, 1)");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
								VALUES (1, 'Left Sidebox', 'lsblock', 0, 1)");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
								VALUES (1, 'Right Sidebox', 'rsblock', 0, 1)");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
								VALUES (1, 'News-Index(std)', 'News-index', 0, 1)");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
								VALUES (1, 'News-article', 'News-article', 0, 1)");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
								VALUES (1, 'News-index(2col)', 'News-index2', 1, 1)");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
								VALUES (1, 'Top CenterBlock', 'topcenter', 1, 1)");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
								VALUES (1, 'TopCenter Box', 'tcblock', 1, 1)");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
								VALUES (1, 'Bottom CenterBlock', 'botcenter', 1, 1)");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
								VALUES (1, 'BotCenter Box', 'bcblock', 1, 1)");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
								VALUES (1, 'InnerBlock', 'inblock', 1, 1)");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
								VALUES (1, 'InnerBlock Sidebox', 'isblock', 1, 1)");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
								VALUES (1, 'Default Sidebox', 'dsblock', 1, 1)");
		$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
								VALUES (1, 'Main Menu Block', 'mainmenu', 1, 1)");


				  echo "OK<br><br>";

				echo "Making Envolved default theme ... ";
				SaveConfigValue ('/PNConfig','Default_Theme','Envolved',1);
				echo "OK<br><br>";

				echo "If everything was ok (no errors/warnings shown), then the last step is just to delete this file and go to your site. Now you can insert back any theme you want<br><br>";

				echo "The Envolution Team wants to thank you for your patience and comprenssion and wants to apologize for any inconvenience this bug made.<br><br><br>";

				echo "Si todo ha sido correcto (no se han mostrado errores o avisos), el ltimo paso que queda es borrar este fichero e ir a tu sitio. Ahora puedes instalar cualquier theme que desees<br><br>";

				echo "El Equipo de Envolution quiere agradecerte tu paciencia y comprensin y te pide disculpas por cualquier inconveniente que te haya podido producir este error.<br><br><br>";

				echo "<b>Remember to delete this file / Recuerda borrar este fichero</b>";
		break;
}

   echo  "
		<center><font class=\"pn-sub\">Thank you for trying Envolution 1.0.1. The Envolution Team</font></center>
		<center><font class=\"pn-sub\">Gracias por utilizar Envolution 1.0.1. El equipo de Envolution</font></center><br>
		</td><td bgcolor=\"#415E74\"></td>
		</tr>
		</table>

		</body>
		</html>";





?>