<?php
// File: $Id: install.php,v 1.1.1.1 2002/09/16 22:18:16 fixxx Exp $ $Name:  $
// ----------------------------------------------------------------------------
// Envolution Content Management System
// Copyright (C) 2002 by the Envolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// ----------------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------------
// Original Author of file:
// Purpose of file:
// ----------------------------------------------------------------------------

/**
 * Envolution Install Script.
 *
 * This script will set the database up, and do the basic configurations of the script.
 * Once this script has run, please delete this file from your root directory.
 * There is a security risk if you keep this file around.
 *
 * The Envolution project is free software released under the GNU License.
 * Please read the credits file for more information on who has made this project possible.
 */


////
// initialize vars, and include all necessary files
set_time_limit(0);

// functions for the db abstraction layer
define('ADODB_DIR', 'pnadodb');
require_once ("pnadodb/adodb.inc.php");

if (isset($alanguage)) {
        $currentlang = $alanguage;
}

if(!isset($prefix)) {
        include_once 'config.php';

        $prefix = $pnconfig['prefix'];
        $dbtype = $pnconfig['dbtype'];
        $dbhost = $pnconfig['dbhost'];
        $dbuname = $pnconfig['dbuname'];
        $dbpass = $pnconfig['dbpass'];
        $dbname = $pnconfig['dbname'];
        $system = $pnconfig['system'];
        $encoded = $pnconfig['encoded'];
}

if (!empty($encoded)) {
        // Decode username and password
        $dbuname = base64_decode($dbuname);
        $dbpass = base64_decode($dbpass);
}

$pnconfig['prefix'] = $prefix;

// database tables information
include_once 'pntables.php';

// functions for multilanguage support
include_once 'install/language.php';

installer_get_language();

// functions to modify config.php
include_once 'install/modify_config.php';

// functions for upgrades
include_once 'install/upgrade.php';

// functions for new installs
include_once 'install/newinstall.php';

// functions for rendering the gui
include_once 'install/gui.php';

// functions for accessing the db
include_once 'install/db.php';

// functions for various checks
include_once 'install/check.php';

// print the page header, include style sheets
print_header();

/*  This starts the switch statement that filters through the form options.
* the @ is in front of $op to suppress error messages if $op is unset and E_ALL
* is on */
switch(@$op) {

    case "CHM_check":
         print_CHM_check();
         break;

    case "Submit":
         print_submit();
         break;

    case "Change Info":
         print_change_info();
         break;

    case "New Install":
         print_new_install();
         break;

    case "Start":
         if(!isset($dbmake)) {
            $dbmake = false;
         }
         make_db($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, $dbmake);
         print_start();
         break;

    case "Continue":
         print_continue();
         break;

    case "Set Login":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         input_data($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, $aid, $name, $pwd, $repeatpwd, $email, $url);
         update_config_php(true); // Scott - added
         print_set_login();
         break;

    case "Select Language":
         print_select_language();
         break;

    case "Set Language":
         $currentlang = $alanguage;
         print_default();
         break;

    case "Finish":
         print_finish();
         break;

    case "Upgrade":
         print_upgrade();
         break;

    case "PostNuke .714":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade714($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype);
         print_success();
         break;

    case "Check":
        do_check_php();
        do_check_chmod();
        break;

    default:
         print_select_language();
         break;
}

// print the footer, and closing tags
print_footer();


?>