<?php
//
// Upgrade script for module Emcompass used with Postnuke to Encompass Theme Engine used in
// Envolution 1.0
//
// Version: 1.0.0
// Date: 2002/09/02
// Author: Marino Carlos
// 
include_once("install/update_functions.php");

function UpdateEncompass() {

  $dbconn = $GLOBALS[dbconn];
  $prefix = $GLOBALS[prefix];
  $numthemes = 7; // number of new themes with Envolution
  
  // Check for previuos installed version of Encompass
  if (CheckTableExists("theme_config")) {
    $result = $dbconn->Execute("RENAME TABLE ".$prefix."_theme_config to tempup_theme_config" );
  }
  if (CheckTableExists("theme_zones")){
    $result = $dbconn->Execute("RENAME TABLE ".$prefix."_theme_zones to tempup_theme_zones" );
  }
  
  if (!CheckTableExists("theme_layout")) {
    $result = $dbconn->Execute("CREATE TABLE ".$prefix."_theme_layout (
			skin_id int(3) NOT NULL default '0',
			zone_label varchar(20) NOT NULL default '',
			tpl_file varchar(20) NOT NULL default '',
		KEY (skin_id))")  ;
  }
  
  if (!CheckTableExists("theme_skins")) {
    $result = $dbconn->Execute("CREATE TABLE ".$prefix."_theme_skins (
			skin_id int(3) NOT NULL auto_increment,
			name varchar(60) NOT NULL default '',
			is_active int(1) NOT NULL default '0',
			is_multicolor int(1) NOT NULL default '0',
			bgcolor1 varchar(12) NOT NULL default '#FFFFFF',
			bgcolor2 varchar(12) NOT NULL default '#FFFFFF',
			bgcolor3 varchar(12) NOT NULL default '#FFFFFF',
			bgcolor4 varchar(12) NOT NULL default '#FFFFFF',
			bgcolor5 varchar(12) NOT NULL default '#FFFFFF',
			bgcolor6 varchar(12) NOT NULL default '#FFFFFF',
			sepcolor varchar(12) NOT NULL default '#000000',
			textcolor1 varchar(12) NOT NULL default '#000000',
			textcolor2 varchar(12) NOT NULL default '#000000',
		PRIMARY KEY  (skin_id))");
  }
  
  // Try to create the table. Will fail if it exists. Not the most elegant, but does the work.
  $result = $dbconn->Execute("CREATE TABLE ".$prefix."_theme_config (
			name varchar(20) NOT NULL default '',
			skin_id int(3) NOT NULL NOT NULL default '1',
			description varchar(60) NOT NULL default '',
			setting varchar(10) NOT NULL default '',
			data varchar(150) NOT NULL default '',
		KEY (skin_id))");  
  
  // Try to create the table. Will fail if it exists. Not the most elegant, but does the work.
  $result = $dbconn->Execute("CREATE TABLE ".$prefix."_theme_zones (
			zone_id int(3) NOT NULL auto_increment,
			skin_id int(3) NOT NULL default '1',
			name varchar(40) NOT NULL default 'No Name',
			label varchar(20) NOT NULL default 'addon',
			type int(1) NOT NULL default '1',
			is_active int(1) NOT NULL default '0',
		PRIMARY KEY  (zone_id),
		KEY (skin_id))");
  
  // Get all the skins already installed on the system.
  // If there are previously installed skins, insert the config and zones on their tables,
  // asigning the correct skin_id
  
  $result = $dbconn->Execute("SELECT DISTINCT skin_id from ".$prefix."_theme_skins");
  while (!$result->EOF) {
    list($skinid) = $result->fields;
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_config (name,skin_id,description,setting,data) SELECT name,$skinid,description,setting,data FROM tempup_theme_config");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (zone_id,skin_id,name,label,type,is_active) SELECT zone_id,$skinid,name,label,type,is_active FROM tempup_theme_zones");
	$result->MoveNext();
  }

  // We don need old config and zones tables any more. Data should be converted in the new tables at this point
  $dbconn->Execute("DROP TABLE tempup_theme_config");
  $dbconn->Execute("DROP TABLE tempup_theme_zones");
  
  // Get the max number for skin_id. We will insert new skins from that number + 1
  $result = $dbconn->Execute("SELECT MAX(skin_id) FROM ".$prefix."_theme_skins");
  if (!$result->EOF) {
    list($maxskinid) = $result->fields;
  } else {
    $maxskinid = 0;
  }

  //Insert skin LogicII
  $dbconn->Execute("INSERT INTO ".$prefix."_theme_skins
                                VALUES (".($maxskinid + 1).",
                                                'LogicII',
                                                1,
                                                0,
                                                '#EFEFEF',
                                                '#C1C2C3',
                                                '#CFCFBB',
                                                '#F7F7F0',
                                                '#FFFFFF',
                                                '#000066',
                                                '#D1CDD2',
                                                '#000000',
                                                '#000000')");

  // Insert skin Envolved
  $dbconn->Execute("INSERT INTO ".$prefix."_theme_skins
                                VALUES (".($maxskinid + 2).",
                                                'Envolved',
                                                1,
                                                0,
                                                '#415E74',
                                                '#415E74',
                                                '#415E74',
                                                '#415E74',
                                                '#99B7CC',
                                                '#415E74',
                                                '#415E74',
                                                '#FFFFFF',
                                                '#FFFFFF')");
  // Insert skin LiquidLogic
  $dbconn->Execute("INSERT INTO ".$prefix."_theme_skins
                                VALUES (".($maxskinid + 3).",
                                                'LiquidLogic',
                                                1,
                                                0,
                                                '#999999',
                                                '#0066CC',
                                                '#999999',
                                                '#CCCCCC',
                                                '#FFFFFF',
                                                '#0066CC',
                                                '#D1CDD2',
                                                '#000000',
                                                '#000000')");
  // Insert skin DuskyBlue
  $dbconn->Execute("INSERT INTO ".$prefix."_theme_skins
                                VALUES (".($maxskinid + 4).",
                                                'DuskyBlue',
                                                1,
                                                0,
                                                '#FFFFFF',
                                                '#CFD5E9',
                                                '#A5B4C4',
                                                '#778899',
                                                '#333333',
                                                '#000000',
                                                '#000000',
                                                '#000000',
                                                '#FFFFFF')");
  // Insert skin X-Indus
  $dbconn->Execute("INSERT INTO ".$prefix."_theme_skins
                                VALUES (".($maxskinid + 5).",
                                                'X-Indus',
                                                1,
                                                0,
                                                '#FFFFFF',
                                                '#D9D9FC',
                                                '#999999',
                                                '#D9D9FC',
                                                '#FFFFFF',
                                                '#0066CC',
                                                '#D1CDD2',
                                                '#000000',
                                                '#000000')");

  // Insert skin PiterpanV2												
  $dbconn->Execute("INSERT INTO ".$prefix."_theme_skins
                                VALUES (".($maxskinid + 6).",
                                                'PiterpanV2',
                                                1,
                                                0,
                                                '#FEFEFE',
                                                '#FEFEFE',
                                                '#E9EDF5',
                                                '#E9EDF5',
                                                '#003058',
                                                '#000066',
                                                '#505050',
                                                '#505050',
                                                '#505050')");
  
  // Insert configuration, zones and layout for the newly inserted skins.
  // $maxskinid still has the max skin_id that was on the table prior to the insertion
  // of new themes. Just insert a copy of settings for all the new skins.
  
  for ($i=1;$i<$numthemes;$i++) {
    $maxskinid ++;
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_config
                                VALUES ('pagewidth',$maxskinid,'"._ENPAGEWIDTH."','100%','')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_config
                                VALUES ('lcolwidth',$maxskinid,'"._ENLCOLWIDTH."','140','')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_config
                                VALUES ('rcolwidth',$maxskinid,'"._ENRCOLWIDTH."','170','')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_config
                                VALUES ('indexcol',$maxskinid,'"._ENINDEXCOL."','1','')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_config
                                VALUES ('righton',$maxskinid,'"._ENRIGHTON."','0','')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_config
                                VALUES ('iblkwidth',$maxskinid,'"._ENINBLKWIDTH."','145','')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
                                VALUES ($maxskinid,'master1','master1.tpl')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
                                VALUES ($maxskinid,'master2','master2.tpl')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
                                VALUES ($maxskinid,'lsblock','lsblock.tpl')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
                                VALUES ($maxskinid,'rsblock','rsblock.tpl')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
                                VALUES ($maxskinid,'table1','table1.tpl')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
                                VALUES ($maxskinid,'table2','table2.tpl')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
                                VALUES ($maxskinid,'News-index','News-index.tpl')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
                                VALUES ($maxskinid,'News-article','News-article.tpl')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
                                VALUES ($maxskinid,'News-index2','News-index2.tpl')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
                                VALUES ($maxskinid, 'topcenter', 'topcenter2.tpl')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
                                VALUES ($maxskinid, 'tcblock', 'tcblock.tpl')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
                                VALUES ($maxskinid, 'botcenter', 'botcenter.tpl')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
                                VALUES ($maxskinid, 'bcblock', 'bcblock.tpl')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
                                VALUES ($maxskinid, 'inblock', 'inblock.tpl')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
                                VALUES ($maxskinid, 'isblock', 'isblock.tpl')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
                                VALUES ($maxskinid, 'dsblock', 'dsblock.tpl')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_layout
                                VALUES ($maxskinid, 'mainmenu', 'mainmenu.tpl')");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
                                VALUES ($maxskinid, '"._ENMASTER1."', 'master1', 0, 1)");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
                                VALUES ($maxskinid, '"._ENMASTER2."', 'master2', 0, 1)");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
                                VALUES ($maxskinid, '"._ENOPENTABLE1."', 'table1', 0, 1)");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
                                VALUES ($maxskinid, '"._ENOPENTABLE2."', 'table2', 0, 1)");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
                                VALUES ($maxskinid, '"._ENLEFTSIDEB."', 'lsblock', 0, 1)");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
                                VALUES ($maxskinid, '"._ENRIGHTSIDEB."', 'rsblock', 0, 1)");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
                                VALUES ($maxskinid, '"._ENNEWSINDEX."', 'News-index', 0, 1)");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
                                VALUES ($maxskinid, '"._ENNEWSART."', 'News-article', 0, 1)");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
                                VALUES ($maxskinid, '"._ENNEWSINDEX2."', 'News-index2', 1, 1)");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
                                VALUES ($maxskinid, '"._ENTOPCENTERBLOCK."', 'topcenter', 1, 1)");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
                                VALUES ($maxskinid, '"._ENTOPCENTERBOX."', 'tcblock', 1, 1)");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
                                VALUES ($maxskinid, '"._ENBOTCENTERBLOCK."', 'botcenter', 1, 1)");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
                                VALUES ($maxskinid, '"._ENBOTCENTERBOX."', 'bcblock', 1, 1)");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
                                VALUES ($maxskinid, '"._ENINNER."', 'inblock', 1, 1)");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
                                VALUES ($maxskinid, '"._ENDEFAULTSIDEB."', 'isblock', 1, 1)");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
                                VALUES ($maxskinid, '"._ENDEFAULTSIDE."', 'dsblock', 1, 1)");
	$dbconn->Execute("INSERT INTO ".$prefix."_theme_zones (skin_id,name,label,type,is_active)
                                VALUES ($maxskinid, '"._ENMAINMENUB."', 'mainmenu', 1, 1)");

  }
  // That's all folks
}
?>