<?php
// File: $Id: pnadminapi.php,v 1.2 2002/09/17 15:11:01 thelinu Exp $ $Name:  $
// Copyright (c) 2002 by Brian K. Virgin (webmaster@envolution.com)
// http://www.envolution.com
// Envolution Content Mangement System - http://www.envolution.com
//
// ----------------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please read the docs/license.txt or visit
// http://www.gnu.org/copyleft/gpl.html
//
// ----------------------------------------------------------------------------
// Filename:        Encompass Theme Configurator                 pnadminapi.php
// Author:                Brian K. Virgin
// Version:                0.926
// Purpose:                Admin API for Encompass Editor
// ----------------------------------------------------------------------------
// Changelog
// 01-02-2002: MADHATter7 - rough draft
// 09-03-2002: mh7 - rewrite to new Encompass Core, rewrite as OO
// 10-03-2002: mh7 - initial codebase
// 24-03-2002: mh7 - rewrite to 0.71x standards and API
// 28-03-2002: mh7 - enhance to use pnHTML
// 01-04-2002: mh7 - zone create, config create & template assign fixes
// 02-04-2002: mh7 - implement admin API
// 22-08-2002: mh7 - full support for skin specific layouts, configs & colors
// 24-08-2002: mh7 - add comments per the Envolution coding spec
// 30-08-2002: apathyboy - fix permission issues
// ----------------------------------------------------------------------------


////
// List all zones for a given skin
// @access                private
// @author                mh7
// @since                0.911                02-04-2002
// @param                integer $skin the current skin ID
// @return                array $array list of skins info
function encompass_adminapi_listZones($args)
{
        // Extract our parameters
        extract($args);

        // Argument check
        if (!isset($skin))
        {
                // Load user API
                if (!pnModAPILoad('Encompass', 'user'))
                {
                        $output = new pnHTML();
                        $output->Text(_ENAPILOADFAIL);
                        return $output->GetOutput();
                }

                $skin = pnModAPIFunc('Encompass','user','getSkinID');
        }

        // Setup db handle
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();

        // Define table & column
        $table = $pntable['theme_zones'];
        $column = &$pntable['theme_zones_column'];

        // Build the query
        $query = "SELECT $column[zone_id],
                                        $column[name],
                                        $column[label],
                                        $column[type],
                                        $column[is_active]
                        FROM $table
                        WHERE $column[skin_id]='$skin'
                        ORDER BY $column[type] ASC,
                                        $column[is_active] DESC,
                                        $column[label] ASC";

        // Execute the query
        $result = $dbconn->Execute($query);

        // If no matches found return false
        if ($result->EOF)
        {
                return false;
        } else {
                // Organize our data
                $array = array();
                while (list($zid, $name, $label, $type, $isactive) = $result->fields)
                {
                        // Move that ADOdb pointer !
                        $result->MoveNext();

                        // Assign to associative array
                        $array[] = array('id'                => $zid,
                                                        'name'                => $name,
                                                        'label'                => $label,
                                                        'type'                => $type,
                                                        'active'        => $isactive);
                }

                // Always close the result set
                $result->Close();

                // return the result
                return $array;
        }
}


////
// List colors for a given skin
// @access                private
// @author                mh7
// @since                0.925                24-08-2002
// @param                integer $skin current skin ID
// @return                array $colors list of colors info
function encompass_adminapi_listColors($args)
{
        // Extract our parameters
        extract($args);

        // Load user API
        if (!pnModAPILoad('Encompass', 'user'))
        {
                $output->Text(_ENAPILOADFAIL);
                return $output->GetOutput();
        }

        // Argument check
        if (!isset($skin))
        {
                $skin = pnModAPIFunc('Encompass','user','getSkinID');
        }

        // Setup db handle
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();

        // Get the current skin name
        $skinName = pnModAPIFunc('Encompass','admin','getSkinFromID',
                                                                array('id' => $skin));

        // define table & column
        $table = $pntable['theme_skins'];
        $column = &$pntable['theme_skins_column'];

        // Build the DB query
        $query = "SELECT $column[bgcolor1],
                                        $column[bgcolor2],
                                        $column[bgcolor3],
                                        $column[bgcolor4],
                                        $column[bgcolor5],
                                        $column[bgcolor6],
                                        $column[sepcolor],
                                        $column[textcolor1],
                                        $column[textcolor2]
                        FROM $table
                        WHERE $column[skin_id]='$skin'";

        // Execute the query
        $result = $dbconn->Execute($query);

        // If no match found report false
        if ($result->EOF)
        {
                return false;
        }

        // Orgnaize and build our data array
        while (list($bcolor1, $bcolor2, $bcolor3, $bcolor4, $bcolor5,
                $bcolor6, $scolor, $tcolor1, $tcolor2) = $result->fields)
        {
                // Move that ADOdb pointer !
                $result->MoveNext();

                // Build the array
                $array[] = array('bcolor1'        => $bcolor1,
                                                'bcolor2'        => $bcolor2,
                                                'bcolor3'        => $bcolor3,
                                                'bcolor4'        => $bcolor4,
                                                'bcolor5'        => $bcolor5,
                                                'bcolor6'        => $bcolor6,
                                                'scolor'        => $scolor,
                                                'tcolor1'        => $tcolor1,
                                                'tcolor2'        => $tcolor2);
        }

        // Always close the result set
        $result->Close();

        // Return the results
        return $array;
}


////
// List colors on a per skin basis
// @access                private
// @author                mh7
// @since                0.911                02-04-2002
// @deprecated        0.925                24-08-2002
// @see                        encompass_adminapi_listColors()
function encompass_adminapi_skinColors()
{
        // pass thru, this function has been deprecated
        // code removed for clarity
}


////
// List configs for the given skin
// @access                private
// @author                mh7
// @since                0.911                02-04-2002
// @param                integer $skin current skin ID
// @return                array $array list of config info
function encompass_adminapi_listConfig($args)
{
        // Extract our parameters
        extract($args);

        if (!isset($skin))
        {
                // Load user API
                if (!pnModAPILoad('Encompass','user'))
                {
                        $output = new pnHTML();
                        $output->Text(_ENAPILOADFAIL);
                        return $output->GetOutput();
                }

                // Assign the current Active Skin
                $skin = pnModAPIFunc('Encompass','user','getSkinID');
        }

        // Setup db handle
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();

        // Setup the table and column
        $table = $pntable['theme_config'];
        $column = &$pntable['theme_config_column'];

        // Build the query
        $query = "SELECT $column[name],
                                        $column[description],
                                        $column[setting]
                        FROM $table
                        WHERE $column[skin_id]='$skin'";

        // Execute the query
        $result = $dbconn->Execute($query);

        // If no matches return false
        if ($result->EOF)
        {
                return false;
        }

        // Organize and build our data array
        while (list($name, $description, $setting) = $result->fields)
        {
                // Move that ADOdb pointer !
                $result->MoveNext();

                // Build the return array
                $array[] = array('name'                        => $name,
                                                'description'        => $description,
                                                'setting'                => $setting);

        }

        // Always close the result set
        $result->Close();

        // Return the results
        return $array;
}


////
// List template file for the given zone
// @access                private
// @author                mh7
// @since                0.911                02-04-2002
// @param                integer $skin current skin ID
// @param                string $zone label for the needed zone
// @return                string $result->fields[0] the template file name
function encompass_adminapi_listTpl($args)
{
        // Extract our parameters
        extract($args);

        // Argument checks
        if (!isset($zone))
        {
                pnSessionSetVar('errormsg', _ENARGSERROR);
                $output = new pnHTML();
                $output->Text(_ENARGSERROR);
                return false;
        }

        // Check parameters
        if (!isset($skin))
        {
                // Load user API
                if (!pnModAPILoad('Encompass','user'))
                {
                        $output->Text(_ENAPILOADFAIL);
                        return $output->GetOutput();
                }

                // Assign the current Active Skin
                $skin = pnModAPIFunc('Encompass','user','getSkinID');
        }

        // Setup the DB handle
        list ($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();

        // Setup the table and column
        $table = $pntable['theme_layout'];
        $column = &$pntable['theme_layout_column'];

        // Build the query
        $query = "SELECT $column[tpl_file]
                        FROM $table
                        WHERE $column[skin_id]='$skin'
                        AND $column[zone_label]='$zone'";

        // Execute the query
        $result = $dbconn->Execute($query);

        // If no matches found report false
        if ($result->EOF)
        {
                return false;
        }

        // Always close the result set
        $result->Close();

        // Return the filename
        return $result->fields[0];
}


////
// Fetch the skin name from a supplied skin ID
// @access                private
// @author                mh7
// @since                0.911                02-04-2002
// @param                integer $is the supplied skin ID
// @return                string $name the corresponding skin name
function encompass_adminapi_getSkinFromID($args)
{
        // Extract our parameters
        extract($args);

        // Parameter check
        if (!isset($id))
        {
                pnSessionSetVar('errormsg', _ENARGSERROR);
                $output = new pnHTML();
                $output->Text("ERROR: "._ENARGSERROR." in adminapi_getSkinFromID");
                return false;
        }

        // Setup the DB handle
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();

        // Setup the table and column info
        $table = $pntable['theme_skins'];
        $column = &$pntable['theme_skins_column'];

        // Buld the query
        $query = "SELECT $column[name]
                        FROM $table
                        WHERE $column[skin_id]='$id'
                        LIMIT 1";

        // Execute the query
        $result = $dbconn->Execute($query);

        // If no matches found return false
        if ($result->EOF)
        {
                return false;
        }

        // Close the result set
        $result->Close();

        // Return the result
        return $result->fields[0];
}


////
// Set the state of the current zone (active|inactive)
// @access                private
// @author                mh7
// @since                0.911                02-04-2002
// @param                integer $skin the current skin ID
// @param                string $zone the zone label we are working with
// @param                string $task the action we are to perform
// @return                bool true upon successful update
function encompass_adminapi_setstate($args)
{
        // Extract our parameters
        extract($args);

        // Argument check
        if (!isset($zone) || !isset($task) || !isset($skin))
        {
                pnSessionSetVar('errormsg', _ENARGSERROR);
                $output = new pnHTML();
                $output->Text("ERROR: "._ENARGSERROR." in adminapi_setstate");
                return false;
        }

        // Permissions check
        if (!pnSecAuthAction(0, 'Encompass::', '::', ACCESS_EDIT))
        {
                pnSessionSetVar('errormsg', _ENCOMPASSAPINOAUTH);
                return false;
        }

        // Setup the DB handle
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();

        // Setup the table and column info
        $table = $pntable['theme_zones'];
        $column = &$pntable['theme_zones_column'];

        // determine the proper task
        switch ($task)
        {
                // Deactivate an active zone
                case 'deactivate':
                        $sql = "UPDATE $table
                                        SET $column[is_active]='0'
                                        WHERE $column[label]='$zone'
                                        AND $column[skin_id]='$skin'";
                        break;

                // Activate an inactive zone
                case 'activate':
                        $sql = "UPDATE $table
                                        SET $column[is_active]='1'
                                        WHERE $column[label]='$zone'
                                        AND $column[skin_id]='$skin'";
                        break;
        }

        // Execute the sql statement
        $result = $dbconn->Execute($sql);

        // Always close the result set
        $result->Close();

        // Update successful, return true
        return true;
}


////
// Update items as requestd
// @access                private
// @author                mh7
// @since                0.911                02-04-2002
// @deprecated        0.925                24-08-2002
// @see                        encompass_adminapi_update() | version 0.911
function encompass_adminapi_update()
{
        // pass thru, this function has been deprecated
        // code removed for clarity
}


////
// Update a zones template file
// @access                private
// @author                mh7
// @since                0.925                24-08-2002
// @param                integer $skin current skin ID
// @param                string $zone the zone we are updating
// @param                string $template tpl file that zone is to use
// @return                bool true upon successful update
// @todo                fix permissions issues
function encompass_adminapi_updateZones($args)
{
        // Check Permissions
        if (!pnSecAuthAction(0, 'Encompass', '::', ACCESS_EDIT))
        {
                pnSessionSetVar('errormsg', _ENCOMPASSNOAUTH);
                return false;
        }

        // Extract our parameters
        extract($args);

        // Argument check
        if (!isset($skin) || !isset($zone) || !isset($tpl))
        {
                pnSessionSetVar('errormsg', _ENARGSERROR);
                return false;
        }

        // Setup the DB handle
        list ($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();

        // Setup the table and columns info
        $table = $pntable['theme_layout'];
        $column = &$pntable['theme_layout_column'];

        // Build the query
        $query = "SELECT $column[tpl_file]
                                FROM $table
                                WHERE $column[skin_id]='$skin'
                                AND $column[zone_label]='$zone'";

        // Execute the query
        $result = $dbconn->Execute($query);

        // Determine if this is a new template or an update
        if (!$result->EOF)
        {
                // Existing entry, update record
                $result->Close();
                $sql = "UPDATE $table
                                SET $column[tpl_file]='$tpl'
                                WHERE $column[skin_id]='$skin'
                                AND $column[zone_label]='$zone'";
        } else {
                // New entry, create record
                $sql = "INSERT INTO $table (
                                        $column[skin_id],
                                        $column[zone_label],
                                        $column[tpl_file]
                                ) VALUES (
                                        '".$skin."',
                                        '".$zone."',
                                        '".$tpl."')";
        }

        // Update the DB
        $result = $dbconn->Execute($sql);

        // Always close the result set
        $result->Close();

        // Update successful, return true
        return true;
}


////
// Update a skins color set
// @access                private
// @author                mh7
// @since                0.925                24-08-2002
// @param                integer $skin ID for the skin
// @param                string $bcolor1 background color #1 (HEX)
// @param                string $bcolor2 background color #2 (HEX)
// @param                string $bcolor3 background color #3 (HEX)
// @param                string $bcolor4 background color #4 (HEX)
// @param                string $bcolor5 background color #5 (HEX)
// @param                string $bcolor6 background color #6 (HEX)
// @param                string $scolor  seperator color (HEX)
// @param                string $tcolor1 text color #1 (HEX)
// @param                string $tcolor2 text color #2 (HEX
// @return                bool true upon successful update
// @todo                fix permissions issues
function encompass_adminapi_updateColors($args)
{
        // Check Permissions
        if (!pnSecAuthAction(0, 'Encompass', '::', ACCESS_EDIT))
        {
                pnSessionSetVar('errormsg', _ENCOMPASSNOAUTH);
                return false;
        }

        // Extract our parameters
        extract($args);

        // check for our parameters
        if (empty($skin))
        {
                pnSessionSetVar('errormsg', _ENARGSERROR);
                return false;
        }

        // Setup the DB handle
        list ($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();

        // Setup the table and column info
        $table = $pntable['theme_skins'];
        $column = &$pntable['theme_skins_column'];

        // Build the update statement
        $sql = "UPDATE $table
                        SET $column[bgcolor1]='$bcolor1',
                                $column[bgcolor2]='$bcolor2',
                                $column[bgcolor3]='$bcolor3',
                                $column[bgcolor4]='$bcolor4',
                                $column[bgcolor5]='$bcolor5',
                                $column[bgcolor6]='$bcolor6',
                                $column[sepcolor]='$scolor',
                                $column[textcolor1]='$tcolor1',
                                $column[textcolor2]='$tcolor2'
                        WHERE $column[skin_id]='$skin'";

        // Update the DB
        $result = $dbconn->Execute($sql);

        // Always close the result set
        $result->Close();

        // Update successful, return true
        return true;
}


////
// Update a skins general configs
// @access                private
// @author                mh7
// @since                0.925                24-08-2002
// @param                integer $skin current skin ID
// @param                string $config anme of the config we are updating
// @param                string $setting the new value of the config
// @return                bool true upon successful update
// @todo                fix permissions issues
function encompass_adminapi_updateConfig($args)
{
        // Check Permissions
        if (!pnSecAuthAction(0, 'Encompass', '::', ACCESS_EDIT))
        {
                pnSessionSetVar('errormsg', _ENCOMPASSNOAUTH);
                return false;
        }

        // Extract our parameters
        extract($args);

        // Argument check
        if (!isset($skin) || !isset($config) || !isset($setting))
        {
                pnSessionSetVar('errormsg', _ENARGSERROR);
                return false;
        }

        // Setup the DB handle
        list ($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();

        // Setup the table and column info
        $table = $pntable['theme_config'];
        $column = &$pntable['theme_config_column'];

        // Buld the update statement
        $sql = "UPDATE $table
                        SET $column[setting]='$setting'
                        WHERE $column[name]='$config'
                        AND $column[skin_id]='$skin'";

        // Update the DB
        $result = $dbconn->Execute($sql);

        // Always close the result set
        $result->Close();

        // Update successful, return true
        return true;
}


////
// Create items as requestd
// @access                private
// @author                mh7
// @since                0.911                02-04-2002
// @deprecated        0.925                24-08-2002
// @see                        encompass_adminapi_create() | version 0.911
function encompass_adminapi_create()
{
        // pass thru, this function has been deprecated
        // code removed for clarity
}


////
// Create new zone
// @access                private
// @author                mh7
// @since                0.925                24-08-2002
// @param                integer $skin current skin ID
// @param                string $zone the zone we are going to create
// @param                string $label long title for the new zone
// @return                bool true upon successful update
// @todo                fix permissions issues
function encompass_adminapi_createZones($args)
{
        // Check Permissions
        if (!pnSecAuthAction(0, 'Encompass', '::', ACCESS_EDIT))
        {
                pnSessionSetVar('errormsg', _ENCOMPASSNOAUTH);
                return false;
        }

        // Extract our parameters
        extract($args);

        // Argument check
        if (!isset($skin) || !isset($zone) || !isset($label))
        {
                pnSessionSetVar('errormsg', _ENARGSERROR);
                return false;
        }

        // Setup the DB handle
        list ($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();

        // Setup the table and column info
        $table = $pntable['theme_zones'];
        $column = &$pntable['theme_zones_column'];

        // Build the query
        $query = "SELECT $column[zone_id]
                                FROM $table
                                WHERE $column[label]='$label'
                                AND $column[skin_id]='$skin'";

        // Execute the query
        $result = $dbconn->Execute($query);

        // Determine if the zone label already exists
        if ($result->EOF)
        {
                // No such label, build the update statement
                $sql = "INSERT INTO $table (
                                        $column[zone_id],
                                        $column[skin_id],
                                        $column[name],
                                        $column[label],
                                        $column[type],
                                        $column[is_active]
                                ) VALUES (
                                        '',
                                        '".$skin."',
                                        '".$zone."',
                                        '".$label."',
                                        1,0)";
        } else {
                // Zone label exists, report error
                $result->Close();
                pnSessionSetVar('errormsg', _ENZONEEXISTS);
                return false;
        }

        // Update the DB
        $result = $dbconn->Execute($sql);

        // Always close the result set
        $result->Close();

        // Update successful, return true
        return true;
}


////
// Create new config
// @access                private
// @author                mh7
// @since                0.911                02-04-2002
// @deprecated        0.925                24-08-2002
// @see                        encompass_adminapi_create() | version 0.911
// @note                never fully implemented, never will be
function encompass_adminapi_createConfig()
{
        // pass thru, this function has been deprecated
        // code removed for clarity
}


////
// Delete items as requestd
// @access                private
// @author                mh7
// @since                0.911                02-04-2002
// @deprecated        0.925                24-08-2002
// @see                        encompass_adminapi_delete() | version 0.911
function encompass_adminapi_delete()
{
        // pass thru, this function has been deprecated
        // code removed for clarity
}

////
// Delete a zone
// @access                private
// @author                mh7
// @since                0.925                24-08-2002
// @param                integer $skin current skin ID
// @param                string $zone the zone we are going to delete
// @return                bool true upon successful removal
// @todo                fix permissions issues
function encompass_adminapi_deleteZones($args)
{
        // Check Permissions
        if (!pnSecAuthAction(0, 'Encompass', '::', ACCESS_EDIT))
        {
                pnSessionSetVar('errormsg', _ENCOMPASSNOAUTH);
                return false;
        }

        // Extract our parameters
        extract($args);

        // Argument check
        if (!isset($skin) || !isset($zone))
        {
                pnSessionSetVar('errormsg', _ENARGSERROR);
                return false;
        }
       // echo "$skin, $zone";
        // Setup the DB handle
        list ($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();

        // Setup the table and column info
        $table = $pntable['theme_zones'];
        $column = &$pntable['theme_zones_column'];

        // Build the query
        $query = "SELECT $column[type]
                                FROM $table
                                WHERE $column[label]='$zone'
                                AND $column[skin_id]='$skin'";

        // Execute the query
        $result = $dbconn->Execute($query);
        $result->Close();

        // Determine if this is a required or addon zone
        if ($result->fields[0] == 1)
        {            
                // Addon Zone, proceed
                $sql = "DELETE FROM $table
                                WHERE $column[label]='$zone'
                                AND $column[skin_id]='$skin'";
        } else {
                // Required Zone, report error
                pnSessionSetVar('errormsg', _ENAPILOADFAILED);
                return false;
        }

        // Update the DB
        $result = $dbconn->Execute($sql);
        $result->Close();

        // Update successful, return true
        return true;
}


////
// Delete a config
// @access                private
// @author                mh7
// @since                0.911                02-04-2002
// @deprecated        0.925                24-08-2002
// @see                        encompass_adminapi_delete() | version 0.911
// @note                never fully implemented, never will be
function encompass_adminapi_deleteConfig()
{
        // pass thru, this function has been deprecated
        // code removed for clarity
}


////
// Create a list of available template files
// @access                private
// @author                mh7
// @since                0.911                02-04-2002
// @param                integer $skin current skin ID
// @param                string $zone the zone we are looking to assign a new template
// @return                array $tpl list of available templates
// @note                not much protection here, use caution
function encompass_adminapi_getTplFiles($args)
{
        // Extract our parameters
        extract($args);

        // Argument check
        if (!isset($skin) || !isset($zone))
        {
                pnSessionSetVar('errormsg', _ENARGSERROR);
                return false;
        }

        // Initialize the template array
        $tpl = array();

        // Get the current skins name
        $skinName = pnModAPIFunc('Encompass','admin','getSkinFromID',
                                                                array('id' => $skin));

        // Open the template directory fo rthe skin
        $dir = opendir('themes/'.$skinName.'/templates');

        // Read through the directory
        while ($file = readdir($dir))
        {
                // Validate the files are indeed templates
                // @note        'prep-' templates are excluded from this list
                if ((substr($file, -3, 3) == 'tpl') && (substr($file, 0, 5) != 'prep-'))
                {
                        // Add valid files to the list
                        $tpl[] = $file;
                }
        }

        // Close the template directory
        closedir($dir);

        // Sort and return the template file names
        sort($tpl);
        return $tpl;
}


////
// Get a general conig info
// @access                private
// @author                mh7
// @since                0.911                02-04-2002
// @param                integer $skin current skin ID
// @param                string $config current config name
// @return                array $array list of config info
function encompass_adminapi_getConfigInfo($args)
{
        // Extract our parameters
        extract($args);

        // Argument check
        if (!isset($skin) || !isset($config))
        {
                pnSessionSetVar('errormsg', _ENARGSERROR);
                return false;
        }

        // Setup DB handle
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();

        // Setup the table and column info
        $table = $pntable['theme_config'];
        $column = &$pntable['theme_config_column'];

        // Build the query
        $query = "SELECT $column[name],
                                        $column[description],
                                        $column[setting]
                        FROM $table
                        WHERE $column[name]='$config'
                        AND $column[skin_id]='$skin'";

        // Execute the query
        $result = $dbconn->Execute($query);

        // If no match found return false
        if ($result->EOF)
        {
                return false;
        }

        // Organize our data
        list($name, $description, $setting) = $result->fields;

        // Close the result set
        // $result->Close();

        // Build the list of info
        $array = array('name'                        => $name,
                                        'description'        => $description,
                                        'setting'                => $setting);

        // return the results
        return $array;
}


////
// Get a list of install skins
// @access                private
// @author                mh7
// @since                0.926                29-08-2002
// @param                none
// @return                array $array list of installed skins info
function encompass_adminapi_getAllSkins()
{
        // Setup DB handle
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();

        // Setup the table and column info
        $table = $pntable['theme_skins'];
        $column = &$pntable['theme_skins_column'];

        // build the query
        $query = "SELECT $column[skin_id],
                                        $column[name]
                        FROM $table
                        WHERE $column[skin_id]>0";

        // Execute the query
        $result = $dbconn->Execute($query);

        // If no match found return false
        if ($result->EOF)
        {
                return false;
        }

        // Organize and build our data array
        while (list($id, $name) = $result->fields)
        {
                // Move that ADOdb pointer !
                $result->MoveNext();

                // Build the return array
                $array[] = array('id'        => $id,
                                                'name'        => $name);

        }

        // Always close the result set
        $result->Close();

        // Return the results
        return $array;
}


////
// Get a list of install skins
// @access                private
// @author                mh7, ApathyBoy
// @since                0.926                29-08-2002
// @param                none
// @return                array $array list of skins from themes dir
function encompass_adminapi_getAllThemes()
{
    $handle = opendir('themes');
    while ($f = readdir($handle))
    {
        if ($f != "." && $f != ".." && $f != "CVS" && $f != "index.html" && !ereg("[.]",$f))
        {
              $newHandle = opendir("themes/$f/");
              while ($a = readdir($newHandle))
              {
                     if ($a == 'encinit.php'){
                         $themelist[] = $f;
                     }
                     else{
                         continue;
                     }
              }
        }

    }
closedir($handle);
/* modif sebastien multi sites le 09/09/2001. */
    $cWhereIsPerso = WHERE_IS_PERSO;
    if (!(empty($cWhereIsPerso))) {
    $handle = opendir('themes');
    while ($f = readdir($handle))
    {
        if ($f == '.' && $f == '..' && $f == 'CVS' && $f == 'index.htm' && !ereg("[.]",$f))
        {
            continue;
        }
        else {
              $newHandle = opendir($f);
              while ($a = readdir($newHandle))
              {
                     if ($a == 'encinit.php'){
                         $themelist[] = $a;
                     }
                     else{
                         continue;
                     }
              }
        }
    }
    }

    return $themelist;
}

////
// Insert New Theme info to the database
// @access                private
// @author                mh7
// @since                0.926                29-08-2002
// @param                none
// @return                bool
function encompass_adminapi_insertNewEnvoTheme($args)
{
        extract($args);

        if (!isset($id))
        {
                pnSessionSetVar('errormsg', _ENARGSERROR);
                return false;
        }

        include_once('themes/'.$id.'/encinit.php');

        if (encompass_skins_install(array('id' => $id)))
        {
                // sucessful install
                return true;
        } else {
                // failure
                return false;
        }
}

////
// Delete Theme from the database
// @access                private
// @author                mh7, ApathyBoy
// @since                0.926                29-08-2002
// @param                none
// @return                bool
function encompass_adminapi_deleteEnvoTheme($args)
{
        extract($args);

        if (!isset($id))
        {
                pnSessionSetVar('errormsg', _ENARGSERROR);
                return false;
        }

        include_once('themes/'.$id.'/encinit.php');

        if (encompass_theme_delete(array('id' => $id)))
        {

        } else {
                // failure
                return false;
        }
}

?>