<?php
// File: $Id: Encompass.php,v 1.1.1.1 2002/09/16 22:18:42 fixxx Exp $ $Name:  $
// Copyright (c) 2002 by Brian K. Virgin (madhatter7@envolution.com)
// http://www.envolution.com
// Envolution Content Management System - http://www.envolution.com
//
// ----------------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please read the docs/license.txt or visit
// http://www.gnu.org/copyleft/gpl.html
//
// ----------------------------------------------------------------------------
// Filename:	Encompass Theme Engine				Encompass.php
// Author:		Brian K. Virgin (MADHATter7)
// Version:		0.926
// Purpose:		Encompass Engine Main File
// ----------------------------------------------------------------------------
// Changelog
// 14-12-2001: mh7		initial release
// 28-12-2001: mh7		fixed private message check
// 28-12-2001: mh7		added is_user check in themeheader
// 04-01-2002: mh7		rewrite to new standard
// 21-01-2002: mh7		cleanup, rearrange, reorganize
// 24-02-2002: mh7		rewrite as OO, consolidate and enhance
// 09-03-2002: sentinel	rewrite themetable, add thememsgbox, correct banners
// 13-03-2002: mh7		rewrite (again) to Rogue 0.71x standards
// 02-04-2002: mh7		correct multi-skin bug, implement user API
// 03-04-2002: mh7		minor PHP 4.1.x syntax corrections
// 22-08-2002: mh7		full support for skin specific layouts and addons
// 25-08-2002: mh7		add comments per the Envolution coding spec
// 29-08-2002: mh7		add skin holder tags handler
// 06-09-2002: Furbo    added support for dhtml block min button
// ----------------------------------------------------------------------------


/*
	NOTE:	This is the last incarnation of the Encompass Theme Engine,
			future versions of Encompass will be for minor tweaks or
			bug fixes only. The new Envolution methods to be implemented
			will replace this code. Encompass will, at that time,
			become the API for modules, addons and blocks to communicate
			directly with the Template Engine --plus an enhanced version
			of the Admin configuration utility.		~mh7
*/


class Encompass {

	// Addon Configuration Variables
	var $inBlockName = "InnerBlock";	// Name of the InnerBlock Addon
	var $tcBlockName = "TopCenter";		// Name of the Top CenterBlock Addon
	var $bcBlockName = "BotCenter";		// Name of the Bottom CenterBlock Addon


///////////////////////////////////////////////////////////////////////////////
// NO NEED TO EDIT BELOW THIS LINE                                           //
///////////////////////////////////////////////////////////////////////////////

    // Internal (private) Variables
	var $DTS;					// DuskyBlue Template System object
	var $DTS_attrib;			// DTS global settings and configs
    var $colorset   = 1;        // holds the custom colorset (DO NOT USE)
    var $thename;				// Basename of the skin directory
    var $themepath;				// Base directory for the skin
    var $skinspath;				// Base directory for the Active Skin
    var $imagepath;				// Base directory for the Active Skin images
    var $numArticles;			// News-index (dual column) config variable
    var $tmp1;					// News-index (dual column) config variable
    var $tmp2;					// News-index (dual column) config variable

    var $zone       = array(    // holds the Layout Zones which are Active
	);

    var $config     = array(    // holds general Engine Configuration info
        'mainpage'  => "News"	// DO NOT EDIT THIS --YOU HAVE BEEN WARNED
	);

    var $skins      = array(	// holds the Skin Configuration info
    );


    //////
    // Initialize Encompass (class constructor)
	// @access		private
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		none
	// @return		none
	// @see			Encompass::init_the_engine()
    function Encompass()
	{
		// Begin all of the processes
		$this->init_the_engine();

    }


	//////
	// Trap legacy OpenTable and OpenTable2 calls in the output buffer
	// @access		private
	// @author		sentinel
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		string $begin the action we are to perform (start|stop)
	// @param		integer $tablenum controls the opentable or opentable2 calls
	// @return		object page output
	function do_themetable($begin, $tablenum='1')
	{
		// Setup the proper zone we are going to display (table1|table2)
		$zone = "table".$tablenum;

		// Check to see which control command was sent
		if ($begin == "start")
		{
			// Start the output buffer
			ob_start();
		} else {
			// Control command was end, assign buffer contents and close it
			$tablecontent = ob_get_contents();
			ob_end_clean();

			// Make sure we have a zone setup
			if (!empty($this->skins[$zone]))
			{
				// Assign the content to a DTS holder
				$this->DTS->assign(array("TABLECONTENT" => $tablecontent));

				// Render the output
				$this->DTS->display($this->skins[$zone]);
			} else {

				// No template for a main zone, trigger error
				// @todo		need to implement better error processing
				$this->tpl_config_error(_MAINZONENOTPL, $zone);
			}
		}
	}


	////
	// Displays the top portion of your Theme
	// @access		private
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		integer $index determines if the right blocks are dispalyed
	// @param		string $name the name of the module we are displaying
	// @param		string $file the modules file we are viewing
	// @param		string $module --deprecated 0.925	25-08-2002	~mh7
	// @return		none
	// @note		this function does prep and engages the output buffer
	//				to trap all further output
	// @note		legacy theme function, includes logo, banners, site messages
	//				blocks['left'] and topcenter blocks
	function do_themeheader($index)
	{
		// @note	mh7		is this really needed still ?
		global $module;

		// Grab our parameters in a secure (API compliant) manner
		list ($name, $module, $file) = pnVarCleanFromInput('name','module','file');

		// Check to see if right blocks are to be displayed or if they
		// are set to always ON
		// @var $index (0=no right blocks; 1=right blocks; 3=no blocks [frontpage])
		// @var $config[righton] (0=normal operation; 1=right blocks on for all pages)
		if ($index == 1 || $this->config['righton'] == 1)
		{
			// Start the output buffer
			ob_start();

			// Call the right blocks
			blocks('right');

			// Assign the contents
			$rightblocks = ob_get_contents();

			// Close the output buffer
			ob_end_clean();
		}

		// If we are not viewing the frontpage, prep the left blocks
		if ($index != 3)
		{
			// Start the output buffer
			ob_start();

			// Call the right blocks
			blocks('left');

			// Assign the contents
			$leftblocks = ob_get_contents();

			// Close the output buffer
			ob_end_clean();
		}

		// Capture the PN centre block in the output buffer
		// @todo		figure out sonmething better here
		// @see			$rightblocks and $leftblocks above
		ob_start();
		blocks('centre');
		$centerblocks = ob_get_contents();
		ob_end_clean();

        // Define the contents of the holder tags for the template engine
		// @note		format is "HOLDER" => contents
		//				this is displayed in your template as: [-$HOLDER-]
        $this->DTS->assign(array(
            "GREETING"      => display_greeting(),
			"NAVTABS"	    => navtabs(),
            "TOPLINKS"      => toplinks(),
            "DATETIME"      => ml_ftime(_DATETIMEBRIEF, (GetUserTime(time()))),
            "LEFTBLOCKS"    => $leftblocks,
            "RIGHTBLOCKS"   => $rightblocks,
			"CENTERBLOCKS"  => $centerblocks,	// Controls the Admin/Site Messages
            "SITENAME"      => pnConfigGetVar('sitename'),
            "SLOGAN"        => pnConfigGetVar('slogan'),
            "_SEARCH"       => _SEARCH,
            "WELCOMETO"     => _WELCOMETO,
			"BOTTOMLINKS"   => bottomlinks()));

		// load custom skin holder tags
		if (file_exists($this->skinspath.'/encTags.php'))
		{
			include_once($this->skinspath.'/encTags.php');
		}

		// Start the output buffering to capture module output
        ob_start();

		// Verify we are on the proper page to display Addon Blocks
		if ($index == 1 && $name == $this->config['mainpage'])
		{
			// Define this addon zone
			$zone = "topcenter";

			// Check if it is active
			if ($this->zone[$zone])
			{
				// Execute the addon
				// @note		topcenter init: call the frame
				//				to hold blocks (topcenter.tpl|topcenter2.tpl)
				$this->do_topcenter('init');
			}
		}
    }


	////
	// Displays the bottom portion of your Theme
	// @access		private
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		integer $index controls if the right blocks are displayed
	// @param		string $name name of the module we are to render
	// @param		string $file name of the modules file we are rendering from
	// @param		string $module --deprecated 0.925	25-08-2002	~mh7
	// @return		object the entire page to be rendered
	// @note		this function completes the output buffering and defines
	//				all holders for the DTS
	// @note		legacy theme function, includes footmsg, bottomlinks,
	//				blocks['right'] and innerblock
	function do_themefooter($index)
	{
		// @see HACK below
		global $my_content;

		// Gather our parameters in a secure [API compliant] manner
		list ($name, $module, $file) = pnVarCleanFromInput('name','module','file');

		// Verify we are on the proper page to display Addon Blocks
		if (($index == 1) && ($name == $this->config['mainpage']))
		{
			// Define the addon zone
			$zone = "inblock";

			// Check to see if the zone is active
			if ($this->zone[$zone])
			{
				// Verify a template file was assigned
				if (!empty($this->skins[$zone]))
				{
					// Execute the addon
					// @note		innerblock init: renders the extra column
					//				(prep-inblock.tpl)
					$this->do_innerblocks('display');
				}
			}
		}

		// Define the master templates
		// @note		master1 is used when right blocks are displayed
		//				master2 is used when no right blocks are displayed
		$zone1 = "master1";
		$zone2 = "master2";

		// Verify we are on the proper page to display Addon Blocks
		if ($index == 1 && $name == $this->config['mainpage'])
		{
			// Define the addon zone
			$zone = "botcenter";

			// Chck to see if the zone is active
			if ($this->zone[$zone])
			{
				// Execute the addon
				// @note		botcenter init: call the frame
				//				to hold blocks (botcenter.tpl|botcenter2.tpl)
				$this->do_botcenter('init');
			}
		}

		////
		// HACK:		Allow Encompass to render pnHTML objects correctly
		// @author		neo
		// @since		0.911		02-04-2002
		// @param		object $my_content pnHTML object created by the module
		// @return		object $maincontent moves the object to the proper holder tag
		// @todo		optimize this, pnHTML already buffers this content, when we
		//				reassign it here it is run through the buffer again
		if ($my_content) {
			$maincontent = $my_content;
		} else {
			$maincontent = ob_get_contents();
			ob_end_clean();
		}
		// HACK:		end
		////

		// Assign the main content area to the template engine
		$this->DTS->assign(array(
			'MAINCONTENT' => $maincontent));

		// Determine the correct Master template to call
		if (!empty($this->skins[$zone1]) && !empty($this->skins[$zone2]))
		{
			// Check to see if right blocks are to be displayed or if they
			// are set to always ON
			// @var $index (0=no right blocks; 1=right blocks; 3=no blocks [frontpage])
			// @var $config[righton] (0=normal operation; 1=right blocks on for all pages)
			if ($index == 1 || $this->config['righton'] == 1)
			{
				// Render the page using master1 (right blocks)
				$this->DTS->display($this->skins[$zone1]);
			} else {
				// Render the page using master2 (no right blocks)
				$this->DTS->display($this->skins[$zone2]);
			}
		} else {

			// No template for a main zone, trigger error
			// @todo		need to implement better error processing
			$this->tpl_config_error(_MAINZONENOTPL, $zone1." ".$zone2);
		}
	}


	////
	// Display the stories on the main news page
	// @access		private
	// @author		mh7
	// @author		sentinel
	// @since		0.911		02-04-2002
	// @param		array $info holds the info array built by the news module
	// @param		array $links holds the links array built by the news module
	// @param		array $preformat holds the preformatted array built by the news module
	// @param		integer $index controls if the right blocks are displayed
	// @param		string $name the name of the module to render
	// @param		string $file the name of the modules file
	// @return		object the page output
	// @todo		seperate the dual news column code into an addon in order to
	//				cleanup this section and remove that code if not needed
    function do_themeindex($info, $links, $preformat, $index)
	{
		// Gather our parameters in a secure [API compliant] manner
		list ($name, $file) = pnVarCleanFromInput('name','file');

		// Verify we are on the proper page to display Addon Blocks
		if (($index == 1) && ($this->pasthead != 1) && ($name == $this->config['mainpage']))
		{
			// Define the addon zone
			$zone = "inblock";

			// Check for InnerBlock Status
			if ($this->zone[$zone])
			{
				// Execute the innerblock addon
				$this->do_innerblocks('init');
			}

			// Pointer to avoid repeating this section each time
			// themeindex() is called. (0=run above code; 1=already performed)
			$this->pasthead = 1;
		}

        if (!empty($info[tid])) {

			// Define the zone (News-index)
			$zone = "$name-$file";

            // Setup the News Arrays
            $this->set_pn_attrib($info, $links, $preformat);

			// Assign some helpful template engine tags
            $this->DTS->assign(array(
                "_POSTEDBY" => _POSTEDBY,	// language define
                "_ON"       => _ON,			// language define
                "_READS"    => _READS));	// language define

            // Dual Column News Page
            if ($this->config['indexcol'] == "2")
			{
				// Increase the number of articles counter
                $this->numArticles++;
                if($this->numArticles > 2)
				{
					// More than 2 articles
					// If the number of articles/2 has no remainder
                    if(($this->numArticles % 2) == 0)
					{
						// Fetch the output of the template and assign it to tmp2
                        $this->tmp2 = $this->DTS->fetch($this->skins[$zone]);

						// Assign the holder tags for the two column news page
                        $this->DTS->assign(
							array("COLUMN1" => $this->tmp1,
								"COLUMN2" => $this->tmp2));

						// Verify a template has been assigned to this zone
                        if (!empty($this->skins[$zone."2"]))
						{
							// Render the output
                            $this->DTS->display($this->skins[$zone."2"]); //dualindex
                        }
                    } else {

						// Fetch the output of the template and assign it to tmp1
                        $this->tmp1 = $this->DTS->fetch($this->skins[$zone]);
                    }
                } else {

					// Less than two articles
					// Check to see if the zone is active
                    if (!empty($this->skins[$zone])) {

						// Render the page
                        $this->DTS->display($this->skins[$zone]);
                    } else {

						// No template for a main zone, trigger error
						// @todo		need to implement better error processing
                        $this->tpl_config_error(_MAINZONENOTPL, $zone);
                    }
                }
            }

			// Single Column News Page
            if ($this->config['indexcol'] == "1") {

				// Check to see if this zone is active
                if (!empty($this->skins[$zone]))
				{
					// Render the page
                    $this->DTS->display($this->skins[$zone]);
                } else {

					// No template for a main zone, trigger error
					// @todo		need to implement better error processing
                    $this->tpl_config_error(_MAINZONENOTPL, $zone);
                }
            }
        }
    }


	////
	// Display the entire article on its own page
	// @access		private
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		array $info holds the info array built by the news module
	// @param		array $links holds the links array built by the news module
	// @param		array $preformat holds the preformatted array built by the news module
	// @param		string $name the name of the module to render
	// @param		string $file the name of the modules file
	// @return		object the page output
    function do_themearticle($info, $links, $preformat)
	{
		// Grab our parameters in a secure [API comliant] manner
		list ($name, $file) = pnVarCleanFromInput('name','file');

		// Assign the module name and file to a zone
		$zone = "$name-$file";

		// Check for admin edit status
		if (pnSecAuthAction(0, 'Stories::', "$info[aid]:$info[cattitle]:$info[sid]", ACCESS_EDIT))
		{
			// Add an "edit" link for admins
			$adm = "<br /><span class=\"pn-sub\"> [ "
				."<a href=\"admin.php?module=NS-AddStory"
				."&amp;op=EditStory&amp;sid=$info[sid]\">"
				._EDIT."</a> ";
		}

		// Check for admin delete status
		if (pnSecAuthAction(0, 'Stories::', "$info[aid]:$info[cattitle]:$info[sid]", ACCESS_DELETE))
		{
			// Add a "delete" link for admins
			$adm .= "| <a href=\"admin.php?module=NS-AddStory"
				."&amp;op=RemoveStory&amp;sid=$info[sid]\">"
				._DELETE."</a> ]</span><br />\n";
		}

		// Send info, links and preformat arrays to be assigned
		$this->set_pn_attrib($info, $links, $preformat);

		// Verify the zone is active
		if (!empty($this->skins[$zone]))
		{
			// Assign some useful handle tags to the template engine
			$this->DTS->assign(array(
				"ADMIN"     => $adm,			// Edit/Delete links built above
				"_ON"       => _ON,				// Language definition
				"_POSTEDBY" => _POSTEDBY));		// Language definition

			// Render the page
			$this->DTS->display($this->skins[$zone]);
		} else {

			// No template for a main zone, trigger error
			// @todo		need to implement better error processing
			$this->tpl_config_error(_MAINZONENOTPL, $zone);
		}
	}


	////
	// Display the sideboxes using templates
	// @access		private
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		array $block sideblock info
	// @param		integer $index --deprecated 0.925	25-08-2002	~mh7
	// @return		object the themed sideblock output
	// @todo		find a faster/better way to format block titles,
	//				currently uses: ereg_replace("[^0-9a-z_]","",$blocktitle);
    function do_themesidebox($block, $index='0')
	{
		// If there is no position info, this controls the look of the block
		// (l=left; r=right; d=default; t=top; b=bottom; i=inner)
		if(empty($block['position'])) {
			$block['position'] = 'd';
		}

		// New [0.710] method:	Yes, I know it's ugly (PN Centre Block is BAD)
		if($block['position'] == 'c')
		{
			echo "<font class=\"pn-normal\">$block[content]</font>";
		}

		// Determine the postion and template for the block
		if ($block[position] == "t" || $block[position] == "b")
		{
			// Assign different templates to top and bottom centerblocks
			$zone = $block['position']."cblock";
		} else {
			// Normal left, right or inner sideblock templates
			$zone = $block['position']."sblock";
		}

		// Assign the block title and contents in the template engine
        // Furbo.. add MinBox and DHTML wrapper for content
		        $this->DTS->assign(array(
		            "TITLE"     => $block['title'],
		            "CONTENT"   => $block['dhtmlRegionStart'].$block['content'].$block['dhtmlRegionEnd'],
		            "MINBOX"    => $block['MinBox']
            ));

        // Convert block[title] to lowercase / remove all non-alpha characters
        $blocktitle = strtolower(strip_tags($block['title']));
        $blocktitle = ereg_replace("[^0-9a-z_]","",$blocktitle);

        // Check to see if there is a zone created for this block
        if (isset($this->zone[$blocktitle]))
		{
            // Yes, display the "highlighted" block template
            $this->DTS->display($this->skins[$blocktitle]);
        } else {

            // No, display the default template for each side
			if (!empty($this->skins[$zone])) {
				$this->DTS->display($this->skins[$zone]);
			}
        }
    }


	////
	// Dispaly a themed message box
	// @access		private
	// @author		sentinel
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		string $process control string for the addon
	// @return		object the themed message box output
	// @note		NOT IMPLEMENTED
	// @todo		determine a way to theme messages in the new Admin
	//				Messages area
	function do_thememsgbox($process)
	{
		// Load the addon file
		$this->loadAddon($this->msgBoxName);

		// Init the Extension Class
		$enMsgBox = new $this->msgBoxName;

		// Transfer some variables to the extension
		$enMsgBox->DTS			= $this->DTS;			// template engine object
		$enMsgBox->themepath	= $this->themepath;		// backwards compatability
		$enMsgBox->skinspath	= $this->skinspath;		// skins path
		$enMsgBox->imagepath	= $this->imagepath;		// images path
		$enMsgBox->config		= $this->config;		// skins config settings
		$enMsgBox->skins		= $this->skins;			// assigned templates list

		// Assign a theme message box function
		$this->DTS->register_function("THEMEMSG","thememsgbox");

		// Verify a process code was specified
		if (!empty($process))
		{
			// Assign the process code to a method call
			$method = "addons_thememsgbox_$process";
			if ($enMsgBox->$method())
			{
				// Load addon successful
				return true;
			}
		}
		// Load addon failed, report false
		return false;
	}


	////
	// Load the innerblock addon
	// @access		private
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		string $process control string for the addon (init|display)
	// @return		bool true upon successful execution of the addon
	// @note		this function is only called when the innerblock zone
	//				is active
	// @todo		write a better, extensible way to load addons in order to
	//				better support third-party developers
	function do_innerblocks($process)
	{
		// Load the addon file
		$this->loadAddon($this->inBlockName);

		// Init the Extension Class
		$enInBlock = new $this->inBlockName;

		// Transfer some variables to the addon extension
		$enInBlock->DTS			= $this->DTS;			// template engine object
		$enInBlock->themepath	= $this->themepath;		// backwards compatability
		$enInBlock->skinspath	= $this->skinspath;		// skins path
		$enInBlock->imagepath	= $this->imagepath;		// images path
		$enInBlock->config		= $this->config;		// skins config settings
		$enInBlock->skins		= $this->skins;			// assigned templates list

		// Assign an advanced blocks function
		$this->DTS->register_function("BLOCK","blocksadv");

		// Verify a process code was specified
		if (!empty($process))
		{
			// Assign the process code to a method call
			$method = "addons_innerblock_$process";
			if ($enInBlock->$method())
			{
				// Load addon successful
				return true;
			}
		}
		// Load addon failed, report false
		return false;
	}


	////
	// Load the top centerblock addon
	// @access		private
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		string $process control string for the addon (init|display)
	// @return		bool true upon successful execution of the addon
	// @note		this function is only called when the topcenter zone
	//				is active
	// @todo		write a better, extensible way to load addons in order to
	//				better support third-party developers
	function do_topcenter($process)
	{
		// Load the addon file
		$this->loadAddon($this->tcBlockName);

		// Init the Extension Class
		$enTcBlock = new $this->tcBlockName;

		// Transfer some variables to the extension
		$enTcBlock->DTS		= $this->DTS;		// template engine object
		$enTcBlock->skins	= $this->skins;		// assigned templates list

		// Verify a process code was specified
		if (!empty($process))
		{
			// Assign the process code to a method call
			$method = "addons_topcenter_$process";
			if ($enTcBlock->$method())
			{
				// Load addon successful
				return true;
			}
		}
		// Load addon failed, report false
		return false;
	}


	////
	// Load the bottom centerblock addon
	// @access		private
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		string $process control string for the addon (init|display)
	// @return		bool true upon successful execution of the addon
	// @note		this function is only called when the botcenter zone
	//				is active
	// @todo		write a better, extensible way to load addons in order to
	//				better support third-party developers
	function do_botcenter($process)
	{
		// Load the addon file
		$this->loadAddon($this->bcBlockName);

		// Init the Extension Class
		$enBcBlock = new $this->bcBlockName;

		// Transfer some variables to the extension
		$enBcBlock->DTS		= $this->DTS;		// template engine object
		$enBcBlock->skins	= $this->skins;		// assigned templates list

		// Verify a process code was specified
		if (!empty($process))
		{
			// Assign the process code to a method call
			$method = "addons_botcenter_$process";
			if ($enBcBlock->$method())
			{
				// Load addon successful
				return true;
			}
		}
		// Load addon failed, report false
		return false;
	}


///////////////////////////////////////////////////////////////////////////////
// BEGIN ENGINE CONFIG METHODS                                               //
///////////////////////////////////////////////////////////////////////////////


	////
	// Assigns the PN info, links and preformat arrays to the template engine
	// @access		private
	// @author		sentinel
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		array $info article info array
	// @param		array $links article links array
	// @param		array $preformat article preformatted info array
	// @return		none
	function set_pn_attrib($info, $links, $preformat)
	{
		$this->DTS_attrib = array(
			"INFO"  => $info,
			"LINKS" => $links,
			"PRE"   => $preformat
		);
		$this->DTS->assign($this->DTS_attrib);
	}


	////
	// Begin the initilization process for Encompass
	// @access		private
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		none
	// @return		none
	// @note		creates the DTS object for the class
	//				assigns values to internal variables
	// @note		MULTI-COLOR TEMPLATES NOT IMPLEMENTED
	function init_the_engine()
	{
		// Load user API
		if (!pnModAPILoad('Encompass', 'user'))
		{
			pnSessionSetVar('errormsg', _ENAPILOADFAILED);
		}

		// Assign the skins name and ID
		$this->skins['name']  = pnModAPIFunc('Encompass','user','getSkinName');
		$this->skins['id']    = pnModAPIFunc('Encompass','user','getSkinID',
												array(
													'skin' => $this->skins['name']
												));

		// Assign some basic paths for the engine and skins
		$this->thename      = $this->skins['name'];
        $this->themepath    = "themes/".$this->thename;

		// Backwards compatability with previous Encompass themes
		$this->skinspath    = $this->themepath;
		$this->imagepath    = $this->skinspath."/images";

		// Initialize the DuskyBlue Theme System (templates)
		$this->DTS = pnModAPIFunc('Encompass','user','themeInit',
										array(
											'skin' => $this->skins['name']
										));

		// Assign the skins general configs
		$this->init_general_config();

		// Intialize the layout & templates
		$this->init_layout($this->skins['id']);

		// Assign custom configs for the DTS
		$this->init_theme_system();

		// Turn off deprecated colors option
		$this->config['multicolor'] = 0;

		// Load the skins colors
		$colors = pnModAPIFunc('Encompass','user','getSkinColors',
									array(
										'skinid' => $this->skins['id']
									));

		// Assign the skins colors to the template system
		$this->assign_global_colors($colors);

		// Load skins advanced functions (if present)
		$this->getSkinsFuncs();

		// Assign some other variables (dual news column support)
		$this->pasthead = 0;
		$this->numArticles = 0;

	}


	////
	// Load and assign the skins general configs
	// @access		private
	// @author		mh7
	// @since		02-04-2002
	// @param		none
	// @return		none
	function init_general_config()
	{
		// Setup the DB handle
		list($dbconn) = pnDBGetConn();
		$pntable = pnDBGetTables();

		// Define the table and columns info
		$table = $pntable['theme_config'];
		$column = &$pntable['theme_config_column'];

		// Build the query
		$query = "SELECT $column[name],
						$column[setting]
					FROM $table
					WHERE $column[skin_id]='".$this->skins['id']."'";

		// Execute the query
		$result = $dbconn->Execute($query);
		if ($dbconn->ErrorNo() != 0)
		{
			// Report the DB error
			$this->db_error((__FILE__), (__LINE__), 'init_general_config',
				$query, $dbconn->ErrorNo(), $dbconn->ErrorMsg());
		} else {
			if (!$result->EOF)
			{
				// Iterate through the results, assign to config
				while (list($name, $setting) = $result->fields)
				{
					// Move the pointer !
					$result->MoveNext();
					$this->config[$name] = $setting;
				}

				// Close the result set
				$result->Close();
			}
		}
	}


	////
	// Load the active zone info
	// @access		private
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		none
	// @return		none
	function init_layout($skinID='')
	{
		// Assign the DB handle
		list($dbconn) = pnDBGetConn();
		$pntable = pnDBGetTables();

		// Define the table columns info
		$column = &$pntable['theme_zones_column'];

		// Build the query
		$query = "SELECT $column[label],
						$column[is_active]
				FROM $pntable[theme_zones]
				WHERE $column[is_active]='1'
				AND $column[skin_id]='$skinID'";

		// Execute the query
		$result = $dbconn->Execute($query);

		if ($dbconn->ErrorNo() != 0)
		{
			// Report the DB error
			$this->db_error((__FILE__), (__LINE__), 'init_layout',
				$query, $dbconn->ErrorNo(), $dbconn->ErrorMsg());
		} else {
			if (!$result->EOF)
			{
				// Iterate through the results, assign to zones
				while (list($label, $active) = $result->fields)
				{
					$result->MoveNext();
					$this->zone[$label] = $active;

					// Initialize the template
					$this->init_template($skinID, $label);
				}

				// Close the result set
				$result->Close();
			}
		}
	}


	////
	// Assign templates for active zones
	// @access		private
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		integer $skinID the active skins ID
	// @param		string $zone the zone to which we are assigning a template
	// @return		none
	// @todo		error handling improvements
	function init_template($skinID='', $zone)
	{
		// Setup the DB handle
		list($dbconn) = pnDBGetConn();
		$pntable = pnDBGetTables();

		// Checdk our parameters
		if (empty($skinID))
		{
			// Assign the active skin
			// @see		encompass_userapi_getSkinName()
			$skinID = $this->skins['id'];
		}

		// Setup the table columns info
		$column = &$pntable['theme_layout_column'];

		// Build the query
		$query = "SELECT $column[tpl_file]
				FROM $pntable[theme_layout]
				WHERE $column[skin_id]='$skinID'
				AND $column[zone_label]='$zone'";

		// Execute the query
		$result = $dbconn->Execute($query);
		if ($dbconn->ErrorNo() != 0)
		{
			// Report the DB error
			$this->db_error((__FILE__), (__LINE__), 'init_template',
				$query, $dbconn->ErrorNo(), $dbconn->ErrorMsg());
		} else {
			if (!$result->EOF)
			{
				// template found, assign it, close result set
				$template = $result->fields[0];
				$result->Close();

				// Make sure this zone is active
				if (!empty($this->zone[$zone]))
				{
					// Verify a template file was found
					if (!empty($template))
					{
						// Assign the template to this zone
						$this->skins[$zone] = "$template";
					}
				}
			} else {

				// No template specified in the dB, try the default filename
				if (file_exists($this->skinspath."/templates/$zone.tpl"))
				{
					// Template found, use it by default
					$this->skins[$zone] = "$zone.tpl";
				} else {

					// No Template found, turn off the Zone
					pnSessionSetVar('errormsg', _NOZONEFOUND.": $zone");
					$this->zone[$zone] = '';
					$this->skins[$zone] = '';
				}
			}
		}
	}


	////
	// Assign the skins colors to the template system
	// @access		private
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		array $colors the skins colors to be assigned
	// @return		none
	// @note		MULTICOLOR SKINS NOT IMPLEMENTED	--deprecated 0.925
	function assign_global_colors($colors)
	{

		// Verify our parameters
		if (empty($colors))
		{
			// Load the active skins colors
			// @see encompass_userapi_getSkinColors()
			$colors = pnModAPIFunc('Encompass','user','getSkinColors',
										array(
											'skinid' => $this->skins['id']
										));
		}

		// See if we are dealing with a multicolor skin
		if ($this->config['multicolor'] == 0)
		{
			// No, define the colors for the template engine
			$this->DTS_attrib = array(
				"BGCOLOR1"      => $colors[bcolor1],
				"BGCOLOR2"      => $colors[bcolor2],
				"BGCOLOR3"      => $colors[bcolor3],
				"BGCOLOR4"      => $colors[bcolor4],
				"BGCOLOR5"      => $colors[bcolor5],
				"BGCOLOR6"      => $colors[bcolor6],
				"SEPCOLOR"      => $colors[scolor],
				"TEXTCOLOR1"    => $colors[tcolor1],
				"TEXTCOLOR2"    => $colors[tcolor2]
			);

			// Assign them for global template use
			$this->DTS->assign($this->DTS_attrib);

		}
	}


	////
	// Load skins custom or advanced functions
	// @access		private
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		string $script the functions filename
	// @return		bool true upon successfully loading the file
	// @note		provided for designers and advanced skins
	// @todo		provide an interface to assign definitions
	//				to the template engine
	function getSkinsFuncs($script='funcs')
	{
		// Verify an advanced functions file exists
		if (file_exists($this->skinspath."/$script.php"))
		{
			// Include the Skins functions file
			include($this->skinspath."/$script.php");
			return true;
		}

		// No file found, return false
		return false;
	}


	////
	// Extend the features of Encompass with addons
	// @access		private
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		string $file the filename we are wanting to load
	// @return		bool true upon successful loading of the addon
	// @note		addons directory moved to skins as of 0.925		24-08-2002
	// @todo		have the addon file perform an init function for
	//				better security and reliability
	function loadAddon($file)
	{
		// Get Encompass module info
		// @deprecated		0.925		25-08-2002
		//$modinfo = pnModGetInfo(pnModGetIDFromName('Encompass'));

		// Verify the addon file exists
		if (file_exists($this->skinspath."/addons/$file.php"))
		{
			// Require the file, report success
			require_once ($this->skinspath."/addons/$file.php");
			return true;
		} else {

			//pnSessionSetVar('errormsg', _LOADADDONFAIL.": $file");
			// File not found, return false
			return false;
		}
	}


///////////////////////////////////////////////////////////////////////////////
// BEGIN ENGINE TEMPLATE SYSTEM INIT                                         //
///////////////////////////////////////////////////////////////////////////////


	////
	// Assign template system attributes and configs
	// @access		private
	// @author		mh7
	// @since		0.911		02-04-2002
	// @param		none
	// @return		none
	// @note		DTS cache (HTML) not properly implemented
	function init_theme_system()
	{
		// Assign PN wrapper functions to the template engine
		$this->DTS->register_function("FOOTMSG","footmsg");			// footer message
		$this->DTS->register_function("BANNERS","themebanners");	// pnBannerDisplay()

		// Define some helpful paths and holder tags
		$this->DTS_attrib = array(
			"THEMEPATH"     => $this->skinspath,			// the skins path (themes/$skinName)
			"IMAGEPATH"     => $this->imagepath,			// image path ($themepath/images)
			"PAGEWIDTH"     => $this->config['pagewidth'],	// entire page width
			"LEFTWIDTH"     => $this->config['lcolwidth'],	// left column width (left blocks)
			"RIGHTWIDTH"    => $this->config['rcolwidth']	// right column width (right blocks)
		);

		// Assign to the template engine for global template use
		$this->DTS->assign($this->DTS_attrib);
	}



///////////////////////////////////////////////////////////////////////////////
// BEGIN ENGINE ERROR HANDLING METHODS                                       //
///////////////////////////////////////////////////////////////////////////////


    //////
    // function:    db_error
    //
    // purpose:     generic db error routine
	function db_error($file='', $line='', $function='', $query='', $ErrorNo, $ErrorMsg)
	{
		echo "<br />"
			."<table algin=\"center\" cellpadding=\"1\" "
			."cellspacing=\"0\" border=\"0\">"
			."<tr><td colspan=\"2\" align=\"center\">"
			."<span class=\"pn-title\"><u>DB Error $ErrorNo</u>"
			."</span></td>"
			."</tr><tr>"
			."<td><span class=\"pn-normal\"><b>File:</b>"
			."</span></td><td><span class=\"pn-sub\">$file</span></td>"
			."</tr><tr>"
			."<td><span class=\"pn-normal\"><b>Function:</b>"
			."</span></td><td><span class=\"pn-sub\">$function</span></td>"
			."</tr><tr>"
			."<td><span class=\"pn-normal\"><b>Line No:</b>"
			."</span></td><td><span class=\"pn-sub\">$line</span></td>"
			."</tr><tr>"
			."<td><span class=\"pn-normal\"><b>Query:</b>"
			."</span></td><td><span class=\"pn-sub\">$query</span></td>"
			."</tr><tr>"
			."<td><span class=\"pn-normal\"><b>Message:</b>"
			."</span></td><td><span class=\"pn-sub\">$ErrorMsg</sapn></td>"
			."</tr></table>";
		exit;
	}


	//////
	// function:	tpl_config_error()
	//
	// purpose:		displays template config errors
	function tpl_config_error($message='', $area='')
	{
		echo _ANERROROCCURED." "._INZONE.": $area<br />";
		echo "<b>$message</b><br />";
		exit;
	}




}	// END Class Encompass


?>