<?php
// File: $Id: pninit.php,v 1.1.1.1 2002/09/16 22:18:42 fixxx Exp $ $Name:  $
// Copyright (c) 2002 by Brian K. Virgin (madhatter7@envolution.com)
// http://www.envolution.com
// Envolution Content Management System - http://www.envolution.com
// 
// ----------------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please read the docs/license.txt or visit
// http://www.gnu.org/copyleft/gpl.html
//
// ---------------------------------------------------------------------------- 
// Filename:	Encompass Theme Engine			pninit.php 
// Author:		Brian K. Virgin
// Version:		0.926
// Purpose:		Install, Upgrade and Uninstall Encompass
// ---------------------------------------------------------------------------- 
// Changelog
// 24-03-2002: mh7 - initial release
// 31-03-2002: mh7 - rewrite to incorporate newer changes
// 02-04-2002: mh7 - major cleanup, correct typos
// 31-05-2002: Zoom - update zones
// 22-08-2002: mh7 - full support for skin specific layouts, configs & colors
// ----------------------------------------------------------------------------



////
// Install the Encompass module
// @access		private
// @author		mh7
// @since		0.911		02-04-2002
// @param		none
// @return		bool true upon successful install
function encompass_init()
{
    // Setup db handle
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Setup table and column info
    $table = $pntable['theme_config'];
    $column = &$pntable['theme_config_column'];

    // CREATE the Config Table
    $create = 
		"CREATE TABLE $table ($column[skin_id] int(3) NOT NULL default '1',
								$column[name] varchar(20) NOT NULL default '',
								$column[description] varchar(60) NOT NULL default '',
								$column[setting] varchar(10) NOT NULL default '',
								$column[data] varchar(150) NOT NULL default '')";

    $dbconn->Execute($create);
    // Check for an error with the database code
    if ($dbconn->ErrorNo() != 0)
	{
        pnSessionSetVar('errormsg', _ENCREATETABLEFAIL." on $table...");
		return false;
    } else {
		// FILL the Config Table
		$populate = "INSERT INTO $table 
						($column[skin_id],
						$column[name], 
						$column[description], 
						$column[setting], 
						$column[data]) 
					VALUES (1,
							'pagewidth',
							'Overall Page Width',
							'100%',
							'')";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id],
						$column[name], 
						$column[description], 
						$column[setting], 
						$column[data]) 
					VALUES (1,
							'lcolwidth',
							'Left Column Width',
							140,
							'')";
		
		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id],
						$column[name], 
						$column[description], 
						$column[setting], 
						$column[data]) 
					VALUES (1,
							'rcolwidth',
							'Right Column Width',
							170,
							'')";
		
		$dbconn->Execute($populate);
		
		$populate = "INSERT INTO $table 
						($column[skin_id],
						$column[name], 
						$column[description],
						$column[setting], 
						$column[data]) 
					VALUES (1,
							'indexcol',
							'Number of News Columns',
							1,
							'')";
				
		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id],
						$column[name], 
						$column[description], 
						$column[setting], 
						$column[data]) 
					VALUES (1,
							'righton',
							'Right Blocks Always On',
							0,
							'')";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id],
						$column[name], 
						$column[description], 
						$column[setting], 
						$column[data]) 
					VALUES (1,
							'iblkwidth',
							'InnerBlock Width',
							145,
							'')";

		$dbconn->Execute($populate);

	}


	// Layout Table
	$table = $pntable['theme_layout'];
	$column = &$pntable['theme_layout_column'];

	// CREATE the Layout Table
	$create =
		"CREATE TABLE $table ($column[skin_id] int(3) NOT NULL default '0',
								$column[zone_label] varchar(20) NOT NULL default '',
								$column[tpl_file] varchar(20) NOT NULL default '',
							KEY $column[skin_id](skin_id))";

	$dbconn->Execute($create);
	// Check for an error with the database code
    if ($dbconn->ErrorNo() != 0)
	{
        pnSessionSetVar('errormsg', _ENCREATETABLEFAIL." on $table...");
		return false;
    } else {
		// FILL the Layout Table
		$populate = "INSERT INTO $table 
						($column[skin_id], 
						$column[zone_label], 
						$column[tpl_file]) 
					VALUES (1,
							'master1',
							'master1.tpl')";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id], 
						$column[zone_label], 
						$column[tpl_file]) 
					VALUES (1,
							'master2',
							'master2.tpl')";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id], 
						$column[zone_label], 
						$column[tpl_file]) 
					VALUES (1,
							'lsblock',
							'lsblock.tpl')";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id], 
						$column[zone_label], 
						$column[tpl_file]) 
					VALUES (1,
							'rsblock',
							'rsblock.tpl')";

		$dbconn->Execute($populate);

		$populate ="INSERT INTO $table 
						($column[skin_id], 
						$column[zone_label], 
						$column[tpl_file]) 
					VALUES (1,
							'table1',
							'table1.tpl')";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id], 
						$column[zone_label], 
						$column[tpl_file]) 
					VALUES (1,
							'table2',
							'table2.tpl')";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id], 
						$column[zone_label], 
						$column[tpl_file]) 
					VALUES (1,
							'News-index',
							'News-index.tpl')";

		$dbconn->Execute($populate);
		// Check for an error with the database code

		$populate = "INSERT INTO $table 
						($column[skin_id], 
						$column[zone_label], 
						$column[tpl_file])	
					VALUES (1,
							'News-article',
							'News-article.tpl')";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id], 
						$column[zone_label], 
						$column[tpl_file]) 
					VALUES (1,
							'News-index2',
							'News-index2.tpl')";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id], 
						$column[zone_label], 
						$column[tpl_file]) 
					VALUES (1,
							'topcenter',
							'topcenter2.tpl')";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id], 
						$column[zone_label], 
						$column[tpl_file]) 
					VALUES (1,
							'tcblock',
							'tcblock.tpl')";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id], 
						$column[zone_label], 
						$column[tpl_file]) 
					VALUES (1,
							'botcenter',
							'botcenter.tpl')";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id], 
						$column[zone_label], 
						$column[tpl_file]) 
					VALUES (1,
							'bcblock',
							'bcblock.tpl')";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id], 
						$column[zone_label], 
						$column[tpl_file]) 
					VALUES (1,
							'inblock',
							'inblock.tpl')";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id], 
						$column[zone_label], 
						$column[tpl_file]) 
					VALUES (1,
							'isblock',
							'isblock.tpl')";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id], 
						$column[zone_label],
						$column[tpl_file]) 
					VALUES (1,
							'mainmenu',
							'mainmenu.tpl')";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[skin_id], 
						$column[zone_label],
						$column[tpl_file]) 
					VALUES (1,
							'dsblock',
							'dsblock.tpl')";

		$dbconn->Execute($populate);


	}


	// Skins Table
	$table = $pntable['theme_skins'];
	$column = &$pntable['theme_skins_column'];

	// CREATE the Skins Table
	$create = 
		"CREATE TABLE $table ($column[skin_id] int(3) NOT NULL auto_increment,
								$column[name] varchar(60) NOT NULL default '',
								$column[is_active] int(1) NOT NULL default '0',
								$column[is_multicolor] int(1) NOT NULL default '0',
								$column[bgcolor1] varchar(12) NOT NULL default '#FFFFFF',
								$column[bgcolor2] varchar(12) NOT NULL default '#FFFFFF',
								$column[bgcolor3] varchar(12) NOT NULL default '#FFFFFF',
								$column[bgcolor4] varchar(12) NOT NULL default '#FFFFFF',
								$column[bgcolor5] varchar(12) NOT NULL default '#FFFFFF',
								$column[bgcolor6] varchar(12) NOT NULL default '#FFFFFF',
								$column[sepcolor] varchar(12) NOT NULL default '#000000',
								$column[textcolor1] varchar(12) NOT NULL default '#000000',
								$column[textcolor2] varchar(12) NOT NULL default '#000000',
							PRIMARY KEY(skin_id))";

	$dbconn->Execute($create);
	// Check for an error with the database code
    if ($dbconn->ErrorNo() != 0)
	{
        pnSessionSetVar('errormsg', _ENCREATETABLEFAIL." on $table...");
		return false;
    } else {
		// FILL the Skins Table
		$populate = "INSERT INTO $table 
						($column[skin_id],
						$column[name], 
						$column[is_active],
						$column[is_multicolor],
						$column[bgcolor1], 
						$column[bgcolor2],
						$column[bgcolor3],
						$column[bgcolor4], 
						$column[bgcolor5],
						$column[bgcolor6],
						$column[sepcolor], 
						$column[textcolor1],
						$column[textcolor2]) 
					VALUES (1,
							'LogicII',
							1,
							0,
							'#EFEFEF',
							'#C1C2C3',
							'#CFCFBB',
							'#F7F7F0',
							'#FFFFFF',
							'#000066',
							'#D1CDD2',
							'#000000',
							'#000000')";

		$dbconn->Execute($populate);

	}


	// Zones Table
	$table = $pntable['theme_zones'];
	$column = &$pntable['theme_zones_column'];

	// CREATE the Zones Table
	$create = 
		"CREATE TABLE $table ($column[zone_id] int(3) NOT NULL auto_increment,
								$column[skin_id] int(3) NOT NULL default '1',
								$column[name] varchar(40) NOT NULL default 'No Name',
								$column[label] varchar(20) NOT NULL default 'addon',
								$column[type] int(1) NOT NULL default '1',
								$column[is_active] int(1) NOT NULL default '0',
							PRIMARY KEY(zone_id),
							KEY $column[type](type))";

	$dbconn->Execute($create);
	// Check for an error with the database code
    if ($dbconn->ErrorNo() != 0)
	{
        pnSessionSetVar('errormsg', _ENCREATETABLEFAIL." on $table...");
		return false;
    } else {
		// FILL the Zones Table
		$populate = "INSERT INTO $table 
						($column[zone_id],
						$column[skin_id],
						$column[name],
						$column[label],
						$column[type],
						$column[is_active]) 
					VALUES ('',
							1,
							'Master Zone 1',
							'master1',
							0,
							1)";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[zone_id],
						$column[skin_id],
						$column[name],
						$column[label],
						$column[type],
						$column[is_active]) 
					VALUES ('',
							1,
							'Master Zone 2',
							'master2',
							0,
							1)";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[zone_id],
						$column[skin_id],
						$column[name],
						$column[label],
						$column[type],
						$column[is_active]) 
					VALUES ('',
							1,
							'OpenTable1',
							'table1',
							0,
							1)";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[zone_id],
						$column[skin_id], 
						$column[name],
						$column[label],
						$column[type],
						$column[is_active]) 
					VALUES ('',
							1,
							'OpenTable2',
							'table2',
							0,
							1)";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[zone_id],
						$column[skin_id], 
						$column[name],
						$column[label],
						$column[type],
						$column[is_active]) 
					VALUES ('',
							1,
							'Left Sidebox',
							'lsblock',
							0,
							1)";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[zone_id],
						$column[skin_id], 
						$column[name],
						$column[label],
						$column[type],
						$column[is_active]) 
					VALUES ('',
							1,
							'Right Sidebox',
							'rsblock',
							0,
							1)";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[zone_id],
						$column[skin_id], 
						$column[name],
						$column[label],
						$column[type],
						$column[is_active]) 
					VALUES ('',
							1,
							'News-Index (std)',
							'News-index',
							0,
							1)";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[zone_id],
						$column[skin_id], 
						$column[name],
						$column[label],
						$column[type],
						$column[is_active]) 
					VALUES ('',
							1,
							'News-article',
							'News-article',
							0,
							1)";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[zone_id],
						$column[skin_id], 
						$column[name],
						$column[label],
						$column[type],
						$column[is_active]) 
					VALUES ('',
							1,
							'News-index (2col)',
							'News-index2',
							1,
							0)";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[zone_id],
						$column[skin_id], 
						$column[name],
						$column[label],
						$column[type],
						$column[is_active]) 
					VALUES ('',
							1,
							'Top CenterBlock',
							'topcenter',
							1,
							0)";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[zone_id],
						$column[skin_id], 
						$column[name],
						$column[label],
						$column[type],
						$column[is_active]) 
					VALUES ('',
							1,
							'TopCenter Box',
							'tcblock',
							1,
							0)";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[zone_id],
						$column[skin_id], 
						$column[name],
						$column[label],
						$column[type],
						$column[is_active]) 
					VALUES ('',
							1,
							'Bottom CenterBlock',
							'botcenter',
							1,
							0)";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[zone_id],
						$column[skin_id], 
						$column[name],
						$column[label],
						$column[type],
						$column[is_active]) 
					VALUES ('',
							1,
							'BotCenter Box',
							'bcblock',
							1,
							0)";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[zone_id],
						$column[skin_id], 
						$column[name],
						$column[label],
						$column[type],
						$column[is_active]) 
					VALUES ('',
							1,
							'InnerBlock',
							'inblock',
							1,
							0)";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[zone_id],
						$column[skin_id], 
						$column[name],
						$column[label],
						$column[type],
						$column[is_active]) 
					VALUES ('',
							1,
							'InnerBlock SideBox',
							'isblock',
							1,
							0)";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[zone_id],
						$column[skin_id], 
						$column[name],
						$column[label],
						$column[type],
						$column[is_active]) 
					VALUES ('',
							1,
							'Main Menu Block',
							'mainmenu',
							1,
							0)";

		$dbconn->Execute($populate);

		$populate = "INSERT INTO $table 
						($column[zone_id],
						$column[skin_id], 
						$column[name],
						$column[label],
						$column[type],
						$column[is_active]) 
					VALUES ('',
							1,
							'Default Sidebox',
							'dsblock',
							1,
							0)";

		$dbconn->Execute($populate);


	}

	// Initialisation successful
	return true;
}



////
// Upgrade the Encompass module
// @access		private
// @author		mh7
// @since		0.911		02-04-2002
// @param		$oldversion	the version number of Encompass that is installed
// @return		bool true upon successful upgrade
// @todo		write the 0.911 -> 0.926 update section
function encompass_upgrade($oldversion) {

    // Upgrade dependent on old version number
    switch($oldversion) {

        case 0.831:
            // Pass thru
			return encompass_upgrade(0.902);

        case 0.902:
            // Pass thru
			return encompass_upgrade(0.911);

		case 0.911:
			// code here to add the skin_id fields
			return encompass_upgrade(0.925);
    }

    // Update successful
    return true;
}



////
// Uninstall the Encompass module
// @access		private
// @author		mh7
// @since		0.911		02-04-2002
// @param		none
// @return		bool true upon successful removal
function encompass_delete() {

    // Setup db variables
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Drop Config Table
    $destroy = "DROP TABLE $pntable[theme_config]";
    $dbconn->Execute($destroy);
    // Check for an error with the database code
    if ($dbconn->ErrorNo() != 0) {
        // Report failed deletion attempt
        return false;
    }

	// Drop Layout Table
	$destroy = "DROP TABLE $pntable[theme_layout]";
	$dbconn->Execute($destroy);
	if ($dbconn->ErrorNo() != 0) {
        // Report failed deletion attempt
        return false;
    }

	// Drop Skins Table
	$destroy = "DROP TABLE $pntable[theme_skins]";
	$dbconn->Execute($destroy);
	if ($dbconn->ErrorNo() != 0) {
        // Report failed deletion attempt
        return false;
    }

	// Drop Zones Table
	$destroy = "DROP TABLE $pntable[theme_zones]";
	$dbconn->Execute($destroy);
	if ($dbconn->ErrorNo() != 0) {
        // Report failed deletion attempt
        return false;
    }

	// Deletion successful
	return true;
}



?>