<?php
// File: $Id: pntables.php,v 1.1.1.1 2002/09/16 22:18:42 fixxx Exp $ $Name:  $
// Copyright (c) 2002 by Brian K. Virgin (madhatter7@envolution.com)
// http://www.envolution.com
// Envolution Content Management System - http://www.envolution.com
// 
// ----------------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------------
// Filename:	Encompass Theme Engine				pntables.php
// Author:		Brian K. Virgin (aka 'MADHATter7')
// Version:		0.925
// Purpose:		Engine Table Definitions
// ----------------------------------------------------------------------------
// Changelog
// 18-02-2002: mh7 - initial release
// 01-03-2002: mh7 - rewrite & simplify
// 13-03-2002: mh7 - enhance for PN Rogue 0.71x
// 22-08-2002: mh7 - full support for skin specific layouts, configs & colors
// ----------------------------------------------------------------------------


////
// Define the tables and columns for Encompass
// @access		private
// @author		mh7
// @since		0.911		02-04-2002
// @param		none
// @return		array $pntable the list of DB table and column info
function encompass_pntables() {

	// Init the array
	$pntable = array();

	// Get the DB prefix
	$prefix = pnConfigGetVar('prefix');

	// General config table and columns
	// mh7: Added 'skin_id' to permit Skin specific configs
	$pntable['theme_config'] = $prefix.'_theme_config';
	$pntable['theme_config_column'] = array(
		'name'			=> "$pntable[theme_config].name",
		'skin_id'		=> "$pntable[theme_config].skin_id",
		'description'	=> "$pntable[theme_config].description",
		'setting'		=> "$pntable[theme_config].setting",
		'data'			=> "$pntable[theme_config].data"
	);

	// Template to zone table and columns
	$pntable['theme_layout'] = $prefix.'_theme_layout';
	$pntable['theme_layout_column'] = array(
		'skin_id'		=> "$pntable[theme_layout].skin_id",
		'zone_label'	=> "$pntable[theme_layout].zone_label",
		'tpl_file'		=> "$pntable[theme_layout].tpl_file"
	);

	// Skins and color table and columns
	$pntable['theme_skins'] = $prefix.'_theme_skins';
	$pntable['theme_skins_column'] = array(
		'skin_id'		=> "$pntable[theme_skins].skin_id",
		'name'			=> "$pntable[theme_skins].name",
		'is_active'		=> "$pntable[theme_skins].is_active",
		'is_multicolor'	=> "$pntable[theme_skins].is_multicolor",
		'bgcolor1'		=> "$pntable[theme_skins].bgcolor1",
		'bgcolor2'		=> "$pntable[theme_skins].bgcolor2",
		'bgcolor3'		=> "$pntable[theme_skins].bgcolor3",
		'bgcolor4'		=> "$pntable[theme_skins].bgcolor4",
		'bgcolor5'		=> "$pntable[theme_skins].bgcolor5",
		'bgcolor6'		=> "$pntable[theme_skins].bgcolor6",
		'sepcolor'		=> "$pntable[theme_skins].sepcolor",
		'textcolor1'	=> "$pntable[theme_skins].textcolor1",
		'textcolor2'	=> "$pntable[theme_skins].textcolor2"
	);

	// Zones table and columns
	// mh7: Added 'skin_id' to permit Skin specific layouts
	$pntable['theme_zones'] = $prefix.'_theme_zones';
	$pntable['theme_zones_column'] = array(
		'zone_id'		=> "$pntable[theme_zones].zone_id",
		'skin_id'		=> "$pntable[theme_zones].skin_id",
		'name'			=> "$pntable[theme_zones].name",
		'label'			=> "$pntable[theme_zones].label",
		'type'			=> "$pntable[theme_zones].type",
		'is_active'		=> "$pntable[theme_zones].is_active"
	);

	// Return the info
	return $pntable;

}


?>