<?php
// File: $Id: index.php,v 1.5 2002/09/26 03:29:32 madhatter7 Exp $ $Name:  $
// Copyright (c) 2002 by Brian K. Virgin (madhatter7@envolution.com)
// http://www.envolution.com
// Envolution Content Management System	- http://www.envolution.com
// 
// ----------------------------------------------------------------------------
// LICENSE
//
// This	program	is free	software; you can redistribute it and/or
// modify it under the terms of	the	GNU	General	Public License (GPL)
// as published	by the Free	Software Foundation; either	version	2
// of the License, or (at your option) any later version.
//
// This	program	is distributed in the hope that	it will	be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A	PARTICULAR PURPOSE.	 See the
// GNU General Public License for more details.
//
// To read the license please read the docs/license.txt	or visit
// http://www.gnu.org/copyleft/gpl.html
//
// ----------------------------------------------------------------------------
// Filename:	Envolution FrontPage				index.php
// Author:		Brian K. Virgin
// Purpose:		Envolution FrontPage Module
// ----------------------------------------------------------------------------
//
// ----------------------------------------------------------------------------


// Start the page, call envTplStart(Module Name,
//									Template file (minus the extension),
//									Value of $index)
envTplStart('Frontpage', 'frontpage', 3);

// Check permissions
if (!pnSecAuthAction(0,	'Frontpage', '::', ACCESS_OVERVIEW))
{
	// Not authorized
	$output	= new pnHTML();
	$output->Text(_FPNOAUTH);
	return $output->GetOutput();
}

// Load	user API
if (!pnModAPILoad('Frontpage', 'user'))
{
	// Error loading the API
	$output	= new pnHTML();
	$output->Text(_FPAPILOADFAILED);
	return $output->GetOutput();
}

// Get the Blocks we are to	display
$blocks	= pnModAPIFunc('Frontpage',	'user',	'getAllBlocks');

// Load	the	Encompass user API
if (!pnModAPILoad('Encompass','user'))
{
	// Error loading Encompass API
	$output	= new pnHTML();
	$output->Text(_ENAPILOADFAILED);
	return $output->GetOutput();
}

// Get the current skin	info
$skinName =	pnModAPIFunc('Encompass','user','getSkinName');
$skinID	= pnModAPIFunc('Encompass','user','getSkinID',
							array('skin' =>	$skinName));

// Load	the	skin colors	we will	use
$colors	= pnModAPIFunc('Encompass',	'user',	'getSkinColors',
							array('skinid' => $skinID));

// Assign the colors
if (!empty($colors))
{
	envTplAssign(array(
		"BGCOLOR1"		=> $colors['bcolor1'],
		"BGCOLOR2"		=> $colors['bcolor2'],
		"BGCOLOR3"		=> $colors['bcolor3'],
		"BGCOLOR4"		=> $colors['bcolor4'],
		"BGCOLOR5"		=> $colors['bcolor5'],
		"BGCOLOR6"		=> $colors['bcolor6'],
		"SEPCOLOR"		=> $colors['scolor'],
		"TEXTCOLOR1"	=> $colors['tcolor1'],
		"TEXTCOLOR2"	=> $colors['tcolor2']));
}

// Iterate throught	the	list of	blocks
for	($x=1; $x<=sizeof($blocks);	$x++)
{
	// Create the holder tag, i.e BLOCK1
	$tmp = "BLOCK$x";

	// Assign to the template engine
	envTplAssign(array(
		$tmp =>	pnModAPIFunc('Frontpage','user','getBlockByName',
									array('block' => $blocks[$x]))));
}

// Assign the imagepath	holder
envTplAssign(array('IMAGEPATH' => envTplImagePath('Frontpage', 'frontpage')));

// Support banners on the Frontpage
envTplRegFunc('BANNERS', 'themebanners');

// Render the template
envTplRender('frontpage');

// End the Page
envTplEnd();


?>