<?php
// File: $Id: theme.php,v 1.1.1.1 2002/09/16 22:18:59 fixxx Exp $ $Name:  $
// Copyright (c) 2002 by Brian K. Virgin (madhatter7@envolution.com)
// http://www.envolution.com
// Envolution Content Management System - http://www.envolution.com
// 
// ----------------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please read the docs/license.txt or visit
// http://www.gnu.org/copyleft/gpl.html
//
// ----------------------------------------------------------------------------
// Filename:    Encompass Theme Engine      theme.php
// Original Author of file:     Brian K. Virgin (aka 'MADHATter7')
// Purpose of file:     Engine for Next Generation Themes
// ----------------------------------------------------------------------------
// Changelog
// 14-12-2001: MADHATter7 - initial release
// 28-12-2001: mh7 - fixed private message check
// 28-12-2001: mh7 - added is_user check in themeheader
// 05-01-2002: mh7 - re-write to new standard
// 21-01-2002: mh7 - re-write previous modifications lost in CPU crash
// 30-01-2002: mh7 - correct Banner placement
// 24-02-2002: mh7 - rewrite as OO, consolidate and enhance
// 28-02-2002: mh7 - strip back down to the "Core" code, complete rewrite
// 13-03-2002: mh7 - rewrite (again) to Rogue 0.710 standards
// 02-04-2002: mh7 - correct multi-skin bug, implement user API
// ----------------------------------------------------------------------------

global $engine;


// First thing is first, load the API
if (!pnModAPILoad('Encompass', 'user')) {
	pnSessionSetVar('errormsg', _ENAPILOADFAILED);
}

// Setup some appropriate variables
// $thename	= "LogicII";
$thename	= basename(dirname(__FILE__));
$themepath	= "themes/$thename";
$postnuke_theme = true;

// Fire it up
$engine = pnModAPIFunc('Encompass','user','init');

// Set global colors for Legacy purposes
$colors = pnModAPIFunc('Encompass','user','getSkinColors');

// Assign colors for legacy purposes
if (!empty($colors)) {
	$bgcolor1   = $colors[bcolor1];
	$bgcolor2   = $colors[bcolor2];
	$bgcolor3   = $colors[bcolor3];
	$bgcolor4   = $colors[bcolor4];
	$bgcolor5   = $colors[bcolor5];
	$bgcolor6   = $colors[bcolor6];
	$sepcolor   = $colors[scolor];
	$textcolor1 = $colors[tcolor1];
	$textcolor2 = $colors[tcolor2];
}

// Load the Language definitions
themes_get_language();

// Legacy Function: Opens 100% table(s) to fit the Theme
// mh7: how about implementing an "opentable" class ?
function OpenTable() {
	global $engine;

	$engine->do_themetable("start", "1");
}


// Legacy Function: Closes the OpenTable()
function CloseTable() {
	global $engine;

	$engine->do_themetable("stop","1");
}


// Legacy Function: Opens table(s) to fit the Theme
// mh7: how about implementing an "opentable2" class ?
function OpenTable2() {
	global $engine;

	$engine->do_themetable("start", "2");
}


// Legacy Function: Closes the OpenTable2()
function CloseTable2() {
	global $engine;

	$engine->do_themetable("stop", "2");
}


// Legacy Function: Renders the Header of the Theme
function themeheader() {
	global $engine, $index;

	//$engine->load_css_file(&$Browser);	mh7: not yet re-implemented
	if ($index != 3) {
		$engine->do_themeheader($index);
	}
}


// Legacy Function: Renders the Footer of the Theme
function themefooter() {
	global $engine, $index;

	if ($index != 3) {
		$engine->do_themefooter($index);
	}
}


// Legacy Function: Displays the Articles on the News Page
// why did they not remove all of these deprecated variables ??
function themeindex ($_deprecated, $_deprecated, $_deprecated, $_deprecated,
	$_deprecated, $_deprecated, $_deprecated, $_deprecated, $_deprecated,
	$_deprecated, $_deprecated, $_deprecated, $info, $links, $preformat) {

	global $engine, $index;

	$engine->do_themeindex($info, $links, $preformat, $index);
}


// Legacy Function: Displays the Article Page when "Read More" is clicked
// why did they not remove all of these deprecated variables ??
function themearticle ($_deprecated, $_deprecated, $_deprecated, $_deprecated,
	$_deprecated, $_deprecated, $_deprecated, $_deprecated, $_deprecated,
	$info, $links, $preformat) {

	global $engine;

	$engine->do_themearticle($info, $links, $preformat);
}


// Legacy Function: Formats the Left and Right Sidblocks
function themesidebox($block) {
	global $engine, $index, $block_side;

	$engine->do_themesidebox($block, $index);
}


// Encompass Function: Wrapper for Exact Banner Placement
function themebanners() {

	// Check for Banners
	if (pnConfigGetVar('banners')) {
		// New [0.710] method
		pnBannerDisplay();
	} else {
		//This line prevents layout disasters
		echo "&nbsp;&nbsp;<br />\n";
	}
}


?>
