<?php
// Re-Design by Enoch Arden (aka Eric Alvarado)
// of http://www.LiquidChain.com
// ---------------------------------------------------------------------------- 
// Copyright (c) 2002 by Brian K. Virgin (webmaster@madhatt.info) 
// http://www.madhatt.info 
// PostNuke Web Portal System - http://www.postnuke.com 
//  
// ---------------------------------------------------------------------------- 
// LICENSE 
// 
// This program is free software; you can redistribute it and/or 
// modify it under the terms of the GNU General Public License (GPL) 
// as published by the Free Software Foundation; either version 2 
// of the License, or (at your option) any later version. 
// 
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
// 
// To read the license please visit http://www.gnu.org/copyleft/gpl.html 
// ---------------------------------------------------------------------------- 
// Filename:    MAD Logic II		funcs.php 
// Original Author of file:     Brian K. Virgin (aka 'MADHATter7') 
// Purpose of file:     Extra functions for the MAd LogicII Skin
// ---------------------------------------------------------------------------- 
// Changelog 
// 13-03-2002: MADHATter7 - initial release under Encompass class
// ----------------------------------------------------------------------------


//////
// function:	toplinks()
//
// purpose:		defines top navigation links in the header
//////
function toplinks() {

	$content = "<a href=\"modules.php?op=modload&name=News"
		."&file=index\">"._LMAIN."</a>\n&nbsp;&nbsp;\n"
		."<a href=\"modules.php?op=modload&name=Topics"
		."&file=index\">"._LTOPICS."</a>\n&nbsp;&nbsp;\n"
		."<a href=\"modules.php?op=modload&name=Sections"
		."&file=index\">"._LSECTIONS."</a>\n&nbsp;&nbsp;\n"
		."<a href=\"modules.php?op=modload&name=Downloads"
		."&file=index\">"._LDOWNLOADS."</a>\n&nbsp;&nbsp;\n"
		."<a href=\"modules.php?op=modload&name=Reviews"
		."&file=index\">"._LREVIEWS."</a>\n&nbsp;&nbsp;\n"
		."<a href=\"user.php\">"._LACCOUNT."</a>\n"
		."&nbsp;&nbsp;\n"
		."<a href=\"modules.php?op=modload&name=Submit_News"
		."&file=index\">"._LSUBMITNEWS."</a>\n&nbsp;&nbsp;\n"
		."<a href=\"modules.php?op=modload&name=Top_List"
		."&file=index\">"._LTOP10."</a>\n";

	return $content;

}


//////adj these as you see fit
// function:	bottomlinks()
// 
// purpose:		defines the bottom navigation links in the footer
//////
function bottomlinks() {

	$content = "<a href=\"http://www.LiquidChain.com\">LiquidLogic Theme</a>&nbsp;&nbsp;"
		."<a href=\"http://www.MadHatt.info\">Encompass Engine</a>&nbsp;&nbsp;";

	return $content;

}


function navtabs() {

// Load the Encompass API
if (!pnModAPILoad('Encompass', 'user')) {
	pnSessionSetVar('errormsg', _ENAPILOADFAILED);
}

// New [0.710] method
$currentlang = pnUserGetLang();
$name = pnVarCleanFromInput('name');

$themepath = "themes/".pnModAPIFunc('Encompass','user','getSkinName');
$imagepath = $themepath."/images";
$imagelangpath=$imagepath."/lang/".$currentlang;

	// set english as the default language if nls files are not found
	if (!file_exists($themepath."/lang/".$currentlang."/global.php")) {
		$imagelangpath=$imagepath."/lang/eng"; 
	}

	// at first disable tabs
	$currmain="off.jpg";
	$currforum="off.jpg";
	$currlinks="off.jpg";
	$currcalendar="off.jpg";
	$currreviews="off.jpg";				

	// decide which one is the current tab,if you want, change all from off.jpg to on.jpg
	// this next part defines which modules you want to use for your main sections (the topnav)
	if (($name == "News") || ($name == "NS-News")) {
		$currmain="off.jpg";
	} elseif (($name == "XForum") || ($name == "NS-XForum")) {
		$currforum="off.jpg";
	} elseif (($name == "Web_Links") || ($name == "NS-Web_Links")) {
		$currlinks="off.jpg";
	} elseif (($name == "PostCalendar") || ($name == "NS-PostCalendar")) {
		$currcalendar="off.jpg";
	} elseif (($name == "Reviews") || ($name == "NS-Reviews")) {
		$currcalendar="off.jpg";
	}

	$content = "<a href=\"modules.php?op=modload&amp;name=News&amp;file=index\">"
		."<img name=\"image1\" valign=\"bottom\" height=\"30\" vspace=\"0\" alt=\"Articles\"" 
		."src=\"$imagelangpath/tab-articles_$currmain\" width=\"100\" border=\"0\""
		."onmouseover=\"image1.src='$imagelangpath/tab-articles_on.jpg';\""
		."onmouseout=\"image1.src='$imagelangpath/tab-articles_$currmain';\" /></a>"

		."<a href=\"modules.php?op=modload&name=XForum&file=index\">"
		."<img name=\"image2\" valign=\"bottom\" height=\"30\" vspace=\"0\" alt=\"Forums\""
		."src=\"$imagelangpath/tab-forums_$currforum\" width=\"100\" border=\"0\""
		."onmouseover=\"image2.src='$imagelangpath/tab-forums_on.jpg';\""
		."onmouseout=\"image2.src='$imagelangpath/tab-forums_$currforum';\" /></a>"

		."<a href=\"modules.php?op=modload&amp;name=Web_Links&amp;file=index\">"
		."<img name=\"image3\" valign=\"bottom\" height=\"30\" vspace=\"0\" alt=\"Weblinks\""
		."src=\"$imagelangpath/tab-weblinks_$currlinks\" width=\"100\" border=\"0\""
		."onmouseover=\"image3.src='$imagelangpath/tab-weblinks_on.jpg';\""
		."onmouseout=\"image3.src='$imagelangpath/tab-weblinks_$currlinks';\" /></a>"

		."<a href=\"modules.php?op=modload&amp;name=PostCalendar&amp;file=index\">"
		."<img name=\"image4\" valign=\"bottom\" height=\"30\" vspace=\"0\" alt=\"Calendar\""
		."src=\"$imagelangpath/tab-calendar_$currcalendar\" width=\"100\" border=\"0\""
		."onmouseover=\"image4.src='$imagelangpath/tab-calendar_on.jpg';\""
		."onmouseout=\"image4.src='$imagelangpath/tab-calendar_$currcalendar';\" /></a>"

		."<a href=\"modules.php?op=modload&amp;name=Reviews&amp;file=index\">"
		."<img name=\"image5\" valign=\"bottom\" height=\"30\" vspace=\"0\" alt=\"reviews\""
		."src=\"$imagelangpath/tab-reviews_$currreviews\" width=\"100\" border=\"0\""
		."onmouseover=\"image5.src='$imagelangpath/tab-reviews_on.jpg';\""
		."onmouseout=\"image5.src='$imagelangpath/tab-reviews_$currreviews';\" /></a>";
				
	return $content;

}


// show the greeting to the visitor
function display_greeting() {

	// New [0.710] method
	list ($dbconn) = pnDBGetConn();
	$pntable = pnDBGetTables();

	// New [0.710] method
	if (pnUserLoggedIn()) {
		// New [0.710] method
		$username = pnUserGetVar('uname');
		$loggedin = _HELLO." <b>".$username."</b>";

		// Gather Users unread messages
		$column1 = &$pntable['users_column'];
		$column2 = &$pntable['priv_msgs_column'];
		$query = "SELECT $column2[to_userid] 
			FROM $pntable[priv_msgs], $pntable[users] 
			WHERE ($column1[uname]='$username' 
			AND $column2[to_userid]=$column1[uid]) 
			AND $column2[read_msg]='0'";

		$result = $dbconn->Execute($query);
		if ($dbconn->ErrorNo() != 0) {
			return false;
		} else {
			if (!$result->EOF) {
				$result->Close();
				$newmsgs = $result->PO_RecordCount();

				if ($newmsgs > 0) {
					$messages = ", "._LYOUHAVE." <a class=\"pn-normal3\" "
					."href=\"modules.php?op=modload&name=Messages"
					."&file=index\">\n<b>$newmsgs</b></a> "._UNREADMSG.".\n";
				}
			} else {
				$messages = ", "._LYOUHAVE." "._LNO." "._UNREADMSG.".\n";
			}
		}
	} else {
		// Not a member, ask them to register/login
		$loggedin = "<b>"._CREATEACCOUNT." <a class=\"pn-normal3\" "
			."href=\"user.php\">"._HERE."</b></a>.\n";
		$messages = "( "._REGISFREE." )\n";
	}
	$greeting = $loggedin." ".$messages."\n";
	return $greeting;
}


?>