<?php
// Copyright (c) 2001 by Brian K. Virgin (webmaster@madhatt.info)
// http://www.madhatt.info
// PostNuke Web Portal System - http://www.postnuke.com
// 
// ----------------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------------
// Filename: Encompass Theme Engine 		pntables.php
// Original Author of file: Brian K. Virgin (aka 'MADHATter7')
// Purpose of file: Engine Table Definitions
// ----------------------------------------------------------------------------
// Changelog
// 18-02-2002: mh7 - initial release
// 01-03-2002: mh7 - rewrite & simplify
// 13-03-2002: mh7 - enhance for Rogue 0.71x
// ----------------------------------------------------------------------------


function encompass_pntables() {

	// Init the array
	$pntable = array();

	// Get the DB prefix
	$prefix = pnConfigGetVar('prefix');

	// Define the table(s) info
	$pntable['theme_config'] = $prefix.'_theme_config';
	$pntable['theme_config_column'] = array(
		'name'			=> "$pntable[theme_config].name",
		'description'	=> "$pntable[theme_config].description",
		'setting'		=> "$pntable[theme_config].setting",
		'data'			=> "$pntable[theme_config].data"
	);

	$pntable['theme_layout'] = $prefix.'_theme_layout';
	$pntable['theme_layout_column'] = array(
		'skin_id'		=> "$pntable[theme_layout].skin_id",
		'zone_label'	=> "$pntable[theme_layout].zone_label",
		'tpl_file'		=> "$pntable[theme_layout].tpl_file"
	);

	$pntable['theme_skins'] = $prefix.'_theme_skins';
	$pntable['theme_skins_column'] = array(
		'skin_id'		=> "$pntable[theme_skins].skin_id",
		'name'			=> "$pntable[theme_skins].name",
		'is_active'		=> "$pntable[theme_skins].is_active",
		'is_multicolor'	=> "$pntable[theme_skins].is_multicolor",
		'bgcolor1'		=> "$pntable[theme_skins].bgcolor1",
		'bgcolor2'		=> "$pntable[theme_skins].bgcolor2",
		'bgcolor3'		=> "$pntable[theme_skins].bgcolor3",
		'bgcolor4'		=> "$pntable[theme_skins].bgcolor4",
		'bgcolor5'		=> "$pntable[theme_skins].bgcolor5",
		'bgcolor6'		=> "$pntable[theme_skins].bgcolor6",
		'sepcolor'		=> "$pntable[theme_skins].sepcolor",
		'textcolor1'	=> "$pntable[theme_skins].textcolor1",
		'textcolor2'	=> "$pntable[theme_skins].textcolor2"
	);

	$pntable['theme_zones'] = $prefix.'_theme_zones';
	$pntable['theme_zones_column'] = array(
		'zone_id'		=> "$pntable[theme_zones].zone_id",
		'name'			=> "$pntable[theme_zones].name",
		'label'			=> "$pntable[theme_zones].label",
		'type'			=> "$pntable[theme_zones].type",
		'is_active'		=> "$pntable[theme_zones].is_active"
	);

	// Return the info
	return $pntable;

}


?>